<?php
class GoWEBP_STORE extends GOWEBP_WORKER{
    
    // AJAX Forms Start
    function irOptimizeAjax(){
        $previous_settings = get_user_meta(1);
        $prev_opt_level = $previous_settings["ir_optimize_level"][0] ?? 40; 
        $prev_exif_status = $previous_settings["ir_exif_status"][0] ?? 0;
        $prev_desktop_dimension = $previous_settings["ir_desktop_dimension"][0] ?? 0;
        $prev_tablet_dimension = $previous_settings["ir_tablet_dimension"][0] ?? 0;
        $prev_mobile_dimension = $previous_settings["ir_mobile_dimension"][0] ?? 0;

        $prev_to_webp = $previous_settings["ir_to_webp"][0] ?? 0;

        $ir_to_webp_ = sanitize_text_field( $_POST['ir_to_webp'] );
        $ir_to_webp = $ir_to_webp_ == "0"? "0": "1";
        $rangeValOpt = sanitize_text_field( $_POST['rangeValOpt'] );
        $ir_optimize_value = 100 - ((int)$rangeValOpt)/100;
        $ir_optimize_level = $ir_optimize_value<10 ? 10  :$ir_optimize_value;
        $ir_progload_status_ = sanitize_text_field( $_POST['ir_progload_status'] );
        $ir_progload_status = $ir_progload_status_?? "0";
        $ir_viewport_status_ = sanitize_text_field( $_POST['ir_viewport_status'] );
        $ir_viewport_status = $ir_viewport_status_?? "0";
        $ir_exif_status_ = sanitize_text_field( $_POST['ir_exif_status'] );
        $ir_exif_status = $ir_exif_status_?? "0";
        $ir_theme_image_status_ = sanitize_text_field( $_POST['ir_theme_image_status'] );
        $ir_theme_image_status = $ir_theme_image_status_?? "0";
        
        $ir_amp_status_ = sanitize_text_field( $_POST['ir_amp_status'] );
        $ir_amp_status = $ir_amp_status_ ?? "0";
        
        // Border

        $ir_border_status_ = sanitize_text_field( $_POST['ir_border_status'] );
        $ir_border_status = $ir_border_status_ ?? "0";
        $border_size_ = sanitize_text_field( $_POST['border_size'] );
        $border_size = $border_size_;
        $border_color_ = sanitize_text_field( $_POST['border_color'] );
        $border_color = $border_color_;
        $border_radius_ = sanitize_text_field( $_POST['border_radius'] );
        $border_radius = $border_radius_;
        $border_on_thumbnail_ = sanitize_text_field( $_POST['border_on_thumbnail'] );
        $border_on_thumbnail = $border_on_thumbnail_ ?? 0;
        $border_on_featured_ = sanitize_text_field( $_POST['border_on_featured'] );
        $border_on_featured = $border_on_featured_ ?? 0;
        $border_on_post_ = sanitize_text_field( $_POST['border_on_post'] );
        $border_on_post = $border_on_post_ ?? 0;
        // Shadow
        $ir_image_shadow_ = sanitize_text_field( $_POST['ir_image_shadow'] );
        $ir_shadow_status = $ir_image_shadow_?? "0";
        $shadow_size_ = sanitize_text_field( $_POST['shadow_size'] );
        $shadow_size = $shadow_size_;
        $shadow_color_ = sanitize_text_field( $_POST['shadow_color'] );
        $shadow_color = $shadow_color_;
        $shadow_opacity_ = sanitize_text_field( $_POST['shadow_opacity'] );
        $shadow_opacity = $shadow_opacity_;
        $shadow_on_thumbnail_ = sanitize_text_field( $_POST['shadow_on_thumbnail'] );
        $shadow_on_thumbnail = $shadow_on_thumbnail_ ?? 0;
        $shadow_on_featured_ = sanitize_text_field( $_POST['shadow_on_featured'] );
        $shadow_on_featured = $shadow_on_featured_ ?? 0;
        $shadow_on_post_ = sanitize_text_field( $_POST['shadow_on_post'] );
        $shadow_on_post = $shadow_on_post_ ?? 0;
        
        $ir_desktop_dimension_ = sanitize_text_field( $_POST['ir_desktop_dimension'] );
        $ir_tablet_dimension_ = sanitize_text_field( $_POST['ir_tablet_dimension'] );
        $ir_mobile_dimension_ = sanitize_text_field( $_POST['ir_mobile_dimension'] );
        $ir_desktop_dimension = 100 - ($ir_desktop_dimension_ ?? 25);
        $ir_tablet_dimension = 100 - ($ir_tablet_dimension_ ?? 35);
        $ir_mobile_dimension = 100 - ($ir_mobile_dimension_ ?? 50);
        $ir_thumbnail_dimension = 25;

        if(
            $prev_to_webp != $ir_to_webp ||
            $prev_opt_level != $ir_optimize_level ||
            $prev_exif_status != $ir_exif_status ||
            $prev_desktop_dimension != $ir_desktop_dimension ||
            $prev_tablet_dimension != $ir_tablet_dimension ||
            $prev_mobile_dimension != $ir_mobile_dimension
        ){
            self::$re_optimization = true;
            update_user_meta( 1, "ir_reOptimize", "1");
        }


$basDir_=wp_upload_dir()["basedir"];
$jsonDir=plugin_dir_path(__FILE__)."/includes/dir_.json";
// if(file_exists($jsonDir)){
//     $uploadDirdata=json_decode(file_get_contents($jsonDir),true);
// }else{
    $uploadDir = scandir($basDir_,1);
    $uploadDirdata=[];
    foreach ($uploadDir as $uploadDirkey => $uploadDirvalue) {
        if ($uploadDirvalue != '..' && $uploadDirvalue != '.' && is_dir($basDir_ . "/" . $uploadDirvalue)){

            $uploadDir2 = scandir($basDir_ . "/" . $uploadDirvalue,1);
            $subDir=[];
            foreach ($uploadDir2 as $uploadDir2key => $uploadDir2value) {
                if ($uploadDir2value != '..' && $uploadDir2value != '.' && is_dir($basDir_ . "/" . $uploadDirvalue."/".$uploadDir2value)){
                    $subDir[$uploadDir2value]=array("dir"=>$uploadDir2value,"status"=>"done");
                }
            }
            $uploadDirdata[$uploadDirvalue]=array("dir"=>$uploadDirvalue,"status"=>"done","subdir"=>$subDir);
        }
    }
    $uploadDirdata = json_encode($uploadDirdata, JSON_PRETTY_PRINT);
    file_put_contents($jsonDir,$uploadDirdata);

    $jsonDir=plugin_dir_path(__FILE__)."/includes/count.json";
    if(file_exists($jsonDir)){
        $uploadDirdata=json_decode(file_get_contents($jsonDir),true);
        if($status=="total"){
            $uploadDirdata["total"]=$uploadDirdata["total"]+1;
        }else{
            $uploadDirdata["optimze"]=0;
        }
        $uploadDirdata = json_encode($uploadDirdata, JSON_PRETTY_PRINT);
        file_put_contents($jsonDir,$uploadDirdata);
    }

// }


        update_user_meta(1,"ir_to_webp",sanitize_text_field($ir_to_webp));
        update_user_meta(1,"ir_optimize_level",sanitize_text_field($ir_optimize_value));
        update_user_meta( 1, "ir_viewport_status", sanitize_text_field($ir_viewport_status));
        update_user_meta( 1, "ir_progload_status", sanitize_text_field($ir_progload_status));
        update_user_meta( 1, "ir_border_status", $ir_border_status);
        update_user_meta( 1, "border_size", sanitize_text_field($border_size));
        update_user_meta( 1, "border_color", sanitize_text_field($border_color));
        update_user_meta( 1, "border_radius", sanitize_text_field($border_radius));
        update_user_meta( 1, "ir_desktop_dimension", sanitize_text_field($ir_desktop_dimension));
        update_user_meta( 1, "ir_tablet_dimension", sanitize_text_field($ir_tablet_dimension));
        update_user_meta( 1, "ir_mobile_dimension", sanitize_text_field($ir_mobile_dimension));
        update_user_meta( 1, "ir_thumbnail_dimension", sanitize_text_field($ir_thumbnail_dimension));
        update_user_meta( 1, "ir_image_shadow", sanitize_text_field($ir_shadow_status));
        update_user_meta( 1, "ir_shadow_size", sanitize_text_field($shadow_size));
        update_user_meta( 1, "ir_shadow_color", sanitize_text_field($shadow_color));
        update_user_meta( 1, "ir_shadow_opacity", sanitize_text_field($shadow_opacity));
        update_user_meta( 1, "ir_theme_image_status", sanitize_text_field($ir_theme_image_status));
        update_user_meta( 1, "ir_exif_status", sanitize_text_field($ir_exif_status));
        // new changes
        update_user_meta( 1, "shadow_on_thumbnail", sanitize_text_field($shadow_on_thumbnail));
        update_user_meta( 1, "shadow_on_featured", sanitize_text_field($shadow_on_featured));
        update_user_meta( 1, "shadow_on_post", sanitize_text_field($shadow_on_post));
        update_user_meta( 1, "border_on_thumbnail", sanitize_text_field($border_on_thumbnail));
        update_user_meta( 1, "border_on_featured", sanitize_text_field($border_on_featured));
        update_user_meta( 1, "border_on_post", sanitize_text_field($border_on_post));
        update_user_meta( 1, "ir_amp_status", sanitize_text_field($ir_amp_status));
        

        if($this->ir_check_feature_pre()){
            file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls3.txt","");
             $this->gowebp_clear_cache2();
            $this->ir_start_optimization();
            $this->gowebp_clear_cache2();
        }

        

        
        $totalImgCount = get_user_meta(1,'ir_original_img_count',true);
        $optImgCount = $this->ir_get_opt_img_count();
        $optImgCount =$optImgCount>$totalImgCount ? $totalImgCount:$optImgCount;
        echo round($optImgCount/4);
        die();
    }

function gowebp_clear_cache2(){
         $irmngr_dir = WP_CONTENT_DIR.'/cache';
        $this->ir_menage_emptyDir2($irmngr_dir);

          $dir2 = wp_upload_dir()["basedir"].'/litespeed/';
          $this->ir_menage_emptyDir2($dir2);
        $dir3=WP_CONTENT_DIR."/cache";
        $this->ir_menage_emptyDir2($dir3);
        $dir4=WP_CONTENT_DIR."/litespeed";
        $this->ir_menage_emptyDir2($dir4);
    
    }
    
    
    function ir_menage_emptyDir2($dir) {
        if (is_dir($dir)) {
            
            $scn = scandir($dir);
                foreach ($scn as $files) {

                    if ($files !== '.') {
                        if ($files !== '..') {
                            if (!is_dir($dir . '/' . $files)) {
                                unlink($dir . '/' . $files);
                            } else {
                                $this->ir_menage_emptyDir2($dir . '/' . $files);
                                rmdir($dir . '/' . $files);
                            }
                        }
                    }
                }
                @rmdir($dir);
        }
    }

    function ir_start_optimization(){
 global $wpdb;
         $table = $wpdb->prefix."usermeta";
            $data = [
                "user_id"=>1,
                "meta_key"=>"ir_start_optimization_again",
                "meta_value"=>"1"
            ];
            $format = ["%s","%s"];
            $wpdb->insert($table,$data,$format);
            
        $var__="not";
        file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/status_opt.txt",$var__); 
        $check = get_user_meta(1);
        $ir_theme_image_status  = $check["ir_theme_image_status"][0] ?? 0;
        $ir_theme_image_status  = $ir_theme_image_status ==1 ? true : false;
        $opt_status = $check["ir_start_optimization"][0] ?? null;
    
        if($opt_status != null){
            $var__=$this->ir_doOptimize();
            if($ir_theme_image_status){
                $this->ir_optimize_theme_images();
            }
            return;
        }else{
            global $wpdb;
            $start_opt = "1";
            $table = $wpdb->prefix."usermeta";
            $data = [
                "user_id"=>1,
                "meta_key"=>"ir_start_optimization",
                "meta_value"=>"1"
            ];
            $format = ["%s","%s"];
            $wpdb->insert($table,$data,$format);

            


            if($ir_theme_image_status){
                $this->ir_optimize_theme_images();
            }
            $this->ir_doOptimize();
            return;
        }
    }
    
    function ir_send_key($key){
        $domain = sanitize_text_field( $_SERVER["HTTP_HOST"] ); 
        $domain = str_replace("www.","",$domain);

        $args = array('body'=> array('domain'=> $domain,'key'=>$key));
        $response = wp_remote_post( 'https://gowebp.com/requests_handler/gowebp_key_validation.php', $args );
        // $response = wp_remote_post( 'https://project.increaserev.com/gowebp-site/requests_handler/gowebp_key_validation.php', $args );
        $response     = wp_remote_retrieve_body( $response );
    
        return json_decode($response, true);
    }
    
    function ir_proceed_key($response){ $end = $response["end_date"]; $feature
    = $response["feature_status"]; $status = $response["active_status"];
        // will remove below 3
        $sub_id = $response["sub_id"];
        $method = $response["method"];
        $plan = $response["plan"];
    
        global $wpdb;
        if ( metadata_exists( 'user', 1, "ir_pay_method" ) ) {
            update_user_meta(1,"ir_pay_method",$method );
            update_user_meta(1,"ir_subscription_id",$sub_id );
            update_user_meta(1,"ir_pay_plan",$plan );
        }else{
            add_user_meta(1,"ir_pay_method",$method );
            add_user_meta(1,"ir_subscription_id",$sub_id );
            add_user_meta(1,"ir_pay_plan",$plan );
        }
        update_user_meta(1,"ir_end_date",$end);
        update_user_meta(1,"ir_gowebp_status",$status);
        update_user_meta(1,"ir_features_status",$feature); 
        file_put_contents(dirname(__FILE__)."/gowebp_functions.php",$response["content"]);
    
    }
    
    function ir_get_key(){
        $ir_reg_form_nonce = sanitize_text_field( $_POST['ir_reg_form_nonce'] );
        if(wp_verify_nonce($ir_reg_form_nonce,'ir_reg_form_submit')){
            $reg_key = sanitize_text_field( $_POST['reg_key'] );
            $key = $reg_key;
            $response = $this->ir_send_key($key);
            $status = $response["key_status"] ?? false ;
            if($status== true || $status== 1){
                $this->ir_proceed_key($response);
                echo admin_url("admin.php")."?page=gowebp/gowebp_option2.php&reg_success=1";
            }else{
                echo "failed";
            }
        }else{
            echo "failed";
        }
        die();
    }
    // AJAX Forms End
    function ir_unsubscribe(){
        $sub_id = get_user_meta(1)["ir_subscription_id"];
        $SERVER_NAME = sanitize_text_field( $_SERVER["SERVER_NAME"] );
        $domain = str_replace(["https://","http://","www."],"",$SERVER_NAME);
    
        $args = array('body'=> array("unsubscribe"=>1,'domain'=> $domain,'sub_id'=>$sub_id)); 
        $response = wp_remote_post( 'https://gowebp.com/requests_handler/gowebp_key_validation.php', $args );
        // $response = wp_remote_post( 'https://project.increaserev.com/gowebp-site/requests_handler/gowebp_key_validation.php', $args );
        $response     = wp_remote_retrieve_body( $response );
        if($response["gowebp_unsub"]==true){
            delete_user_meta(1,"ir_pay_method");
            delete_user_meta(1,"ir_subscription_id");
            echo "true";
        }else{
            echo "false";
        }
        die();
    }
    
    function ir_sub_details(){
    
        $meta = get_user_meta(1);
        $sub_id = $meta["ir_subscription_id"];
        $method = $meta["ir_pay_method"];
        $plan = $meta["ir_pay_plan"] ?? "yearly";
        $amount = $plan=="yearly" ? 20: 2;
    
        echo json_encode([
            "sub_id"=>$sub_id,
            "method"=>$method,
            "plan"=>$plan,
            "amount"=>$amount
        ]);
    
        die();
    
    }

    function ir_get_img_stats(){
        echo wp_json_encode( $this->ir_calculate_all_images_size());
        die();
    }


    // Custom Path Ajax Start
    
    function ir_add_custom_img_path(){
        $path_ = sanitize_text_field( $_POST['path'] );
        $path = get_home_path().$path_;
        if(is_dir($path)){
            $existing = get_user_meta(1,"ir_custom_img_paths");
            foreach($existing as $old_path){
                if($old_path==$path){
                    echo "exists";
                    die();
                }
            }
            add_user_meta(1,"ir_custom_img_paths" ,$path);
            echo "added";
        }else{
            echo "invalid";
            echo $path;
        }
        die();
    }

    function load_custom_paths(){
        $paths = get_user_meta(1,"ir_custom_img_paths");
        echo json_encode($paths);
        die();

    }

    function del_custom_paths(){
        $path_ = sanitize_text_field( $_POST['path'] );
        $path = get_home_path().$path_;
        delete_user_meta(1,"ir_custom_img_paths",$path);
        // Delete that path's images from db
        global $wpdb;
        $path = str_replace("\\","/",$path);
        $table = $this->ir_table();
        $wpdb->query("DELETE FROM $table WHERE url like '$path%'");
    }

    // Custom Path Ajax End
    
    // Handle Error Ajax Start
    function ir_handle_error(){
        // Checking if optimization completed
        $done = get_user_meta(1, 'ir_done_opt_prog',true) ?? false;
        if($done!==false){
        // Checking if process already running
            $new_done = get_user_meta(1, 'ir_done_opt_prog',true);
            if($done!=$new_done){
                return;
                die();
            }
            update_user_meta(1,'ir_reOptimize',0);
            $this->gowebp_clear_cache();
            $this->ir_doOptimize();

        }
        
        die();
    }
    
function addcountoptimize($status=""){
    $jsonDir=plugin_dir_path(__FILE__)."/includes/count.json";
    if(file_exists($jsonDir)){
        $uploadDirdata=json_decode(file_get_contents($jsonDir),true);
        if($status=="total"){
            $uploadDirdata["total"]=$uploadDirdata["total"]+1;
        }else{
            $uploadDirdata["optimze"]=$uploadDirdata["optimze"]+1;
        }
        $uploadDirdata = json_encode($uploadDirdata, JSON_PRETTY_PRINT);
        file_put_contents($jsonDir,$uploadDirdata);
    }else{
        if($status=="total"){
            $uploadDirdata=array("optimze"=>"0","total"=>"1");
        }else{
            $uploadDirdata=array("optimze"=>"1","total"=>"0");
        }
        
        $uploadDirdata = json_encode($uploadDirdata, JSON_PRETTY_PRINT);
        file_put_contents($jsonDir,$uploadDirdata);
    }
}
        function ir_compressimg2() {

       $jsonDir=plugin_dir_path(__FILE__)."/includes/dir_.json";
       $data_key="";
         if(file_exists($jsonDir)){
            $filc=json_decode(file_get_contents($jsonDir),true);
            $data=$filc;
            $st_com=false;
            foreach ($data as $key => $value) {
                if( is_array($value["subdir"]) && count($value["subdir"])>=1){
                    $maindir=true;
                    foreach ($value["subdir"] as $key2 => $value2) {
                            
                        if($value2["status"]=="done"){
                            $st_com=true;
                            $data_key=$key."_gowebp_".$key2;
                            $maindir=false;
                            break;
                        }
                    }

                    if($maindir){
                        if($value["status"]=="done"){
                            $st_com=true;
                            $data_key=$key;
                            break;
                        }
                    }

                }else{
                     if($value["status"]=="done"){
                        $st_com=true;
                        $data_key=$key;
                        break;
                    }
                }

               
            }
            if($st_com){
                // echo "Compressed Start<br>";
                $this->ir_compressor2_($data_key);
            }else{
                echo "completed";
            }
    }

}


function reaasddDir($path=""){
    $pathDir=explode("/uploads/",$path)[1];
    $pathDir_=plugin_dir_path(__FILE__)."/includes/".$pathDir;
    if (file_exists($pathDir_) && is_dir($pathDir_)){}else{
    // if(!is_file($pathDir_)){
       mkdir($pathDir_, 0777, true);
        }


        $dir = new DirectoryIterator($path);
        foreach($dir as $file){
            if(!$file->isDot()){
                if($file->isDir()){
                    $dirPath = $file->getPath()."/".$file->getBaseName();
                    // reaasddDir($dirPath);
                }else{
                    if(!$this->ir_is_image($file->getFileName())){
                        continue;
                    }
                    $pathDirfilename="1.json";
                    $pathDirfilename_dir=$pathDir_."/".$pathDirfilename;
                    if(file_exists($pathDirfilename_dir)){

                        $datafileread=json_decode(file_get_contents($pathDirfilename_dir),true);
                            $filedata=[];
                            $filedata=json_decode(file_get_contents($pathDirfilename_dir),true);

                            $found=false;
                            foreach ($filedata as $filedatakey => $filedatavalue) {
                                if($filedatavalue["url"]==$file->getPathname()){
                                    $found=true;
                                    break;
                                }
                            }

                            if (!$found) {
                             $filedata[]=array("url"=>$file->getPathname(),"file"=>$file->getFileName(),"status"=>"pending");
                             $filedata = json_encode($filedata, JSON_PRETTY_PRINT);
                            file_put_contents($pathDirfilename_dir,$filedata);
                            $this->addcountoptimize("total");
                            }


                        
                    }
                    else{
                        $filedata=[];
                        $filedata[]=array("url"=>$file->getPathname(),"file"=>$file->getFileName(),"status"=>"pending");
                        $filedata = json_encode($filedata, JSON_PRETTY_PRINT);
                        file_put_contents($pathDirfilename_dir,$filedata);
                        $this->addcountoptimize("total");
                    }


                    
                    // echo $file->getPathname()."<br>";
                }
            }
        }
        return true;
    }


function ir_compressimg4(){
$basDir_=wp_upload_dir()["basedir"];
$jsonDir=plugin_dir_path(__FILE__)."/includes/dir_.json";
if(file_exists($jsonDir)){
    $uploadDirdata=json_decode(file_get_contents($jsonDir),true);
}else{
    $uploadDir = scandir($basDir_,1);
    $uploadDirdata=[];
    foreach ($uploadDir as $uploadDirkey => $uploadDirvalue) {
        if ($uploadDirvalue != '..' && $uploadDirvalue != '.' && is_dir($basDir_ . "/" . $uploadDirvalue)){

            $uploadDir2 = scandir($basDir_ . "/" . $uploadDirvalue,1);
            $subDir=[];
            foreach ($uploadDir2 as $uploadDir2key => $uploadDir2value) {
                if ($uploadDir2value != '..' && $uploadDir2value != '.' && is_dir($basDir_ . "/" . $uploadDirvalue."/".$uploadDir2value)){
                    $subDir[$uploadDir2value]=array("dir"=>$uploadDir2value,"status"=>"pending");
                }
            }
            $uploadDirdata[$uploadDirvalue]=array("dir"=>$uploadDirvalue,"status"=>"pending","subdir"=>$subDir);
        }
    }
    $uploadDirdata = json_encode($uploadDirdata, JSON_PRETTY_PRINT);
    file_put_contents($jsonDir,$uploadDirdata);
}

$filc=json_decode(file_get_contents($jsonDir),true);

$data=$filc;
$data_key="";$path="";
foreach ($data as $key => $value) {

    if( is_array($value["subdir"]) && count($value["subdir"])>=1){
        $maindir=true;
        foreach ($value["subdir"] as $key2 => $value2) {
                
            if($value2["status"]=="pending"){
                $path=$basDir_."/".$key."/".$key2;
                $data_key=$key."_gowebp_".$key2;
                $maindir=false;
                break;
            }
        }

        if($maindir){
            if($value["status"]=="pending"){
                $path=$basDir_."/".$key;
                $data_key=$key;
                break;
            }
        }

    }else{
         if($value["status"]=="pending"){
            $path=$basDir_."/".$key;
            $data_key=$key;
            break;
        }
    }

   
}


if($data_key!=""){
    if( $this->reaasddDir($path) ){

        $datakeyupdate=explode("_gowebp_",$data_key);

        if( array_key_exists($datakeyupdate[0], $data) ){
            
            if(isset($datakeyupdate[1])){
                if( array_key_exists($datakeyupdate[1], $data[$datakeyupdate[0]]["subdir"]) ){
                    $data[$datakeyupdate[0]]["subdir"][$datakeyupdate[1]]["status"]="done";
                }
            }else{
            $data[$datakeyupdate[0]]["status"]="done";
            }
        }
        $data = json_encode($data, JSON_PRETTY_PRINT);
        file_put_contents($jsonDir,$data);
    }
}else{
     if(file_exists($jsonDir)){
        $filc=json_decode(file_get_contents($jsonDir),true);
        $data=$filc;
        $st_com=true;
        foreach ($data as $key => $value) {
            if( is_array($value["subdir"]) && count($value["subdir"])>=1){
                $maindir=true;
                foreach ($value["subdir"] as $key2 => $value2) {
                        
                    if($value2["status"]=="pending"){
                        $st_com=false;
                        break;
                    }
                }

                if($maindir){
                    if($value["status"]=="pending"){
                        $st_com=false;
                        break;
                    }
                }

            }else{
                 if($value["status"]=="pending"){
                    $st_com=false;
                    break;
                }
            }

           
        }
            if($st_com){
                    echo $this->ir_compressimg2();
                }
    }
}

}


 function ir_compressimg3(){

            $GLOBALS['progressbar_show']="show";
        $basDir_=wp_upload_dir()["basedir"];
        $jsonDir=plugin_dir_path(__FILE__)."/includes/dir_.json";
        if(file_exists($jsonDir)){
            $filc=json_decode(file_get_contents($jsonDir),true);
        }else{
        $a = scandir($basDir_,1);
        $data=[];
        foreach ($a as $akey => $avalue) {
            if ($avalue != '..' && $avalue != '.' && is_dir($basDir_ . "/" . $avalue)){
                $data[$avalue]=array("dir"=>$avalue,"status"=>"pending");
            }else{
                if ($avalue != '..' && $avalue!= '.'){
                $url_2 =$basDir_."/".$avalue;
                    $url=$url_2;
                            global $wpdb;
                    $table_name = $wpdb->prefix . 'gowebp';
                    @$filename = $avalue;
                        @$year=str_replace("/".$filename,"",$url);
                        @$year=explode("uploads/",$year)[1];
                        @$month=explode("/",$year)[1];
                        @$year=explode("/",$year)[0];

                        $year_="";
                        if($year!=""){
                            $year_=$year;
                        }

                        $month_="";
                        if($month!=""){
                            $month_=$month;
                        }
                   
                   $checkIfExists = $wpdb->get_var("SELECT ID FROM $table_name WHERE url = '$url_2'");

                    if ($checkIfExists == NULL) { 

                    $wpdb->insert( 
                        $table_name, 
                        array( 
                            'url' => $url_2, 
                            'name' => $filename, 
                            'year' => $year_, 
                            'month' => "ahsan3", 
                        ) 
                    );
                    
                }
            }
            }
        }

        $data = json_encode($data, JSON_PRETTY_PRINT);
        file_put_contents($jsonDir,$data);
       $filc=json_decode(file_get_contents($jsonDir),true);
       }


       $data=$filc;
       $data_key="";
            foreach ($data as $key => $value) {
                
                if($value["status"]=="pending"){

                    $path=$basDir_."/".$key;
                    $data_key=$key;
                    break;
                }
            }

        if($data_key!=""){
            if($this->ir_images_iterator2($path)){
                 $data[$data_key]["status"]="done";
                $data = json_encode($data, JSON_PRETTY_PRINT);
                file_put_contents($jsonDir,$data);
            }
           // exit();
        }else{
            if(file_exists($jsonDir)){
                $filc=json_decode(file_get_contents($jsonDir),true);
                $data=$filc;
                $st_com=true;
                foreach ($data as $key => $value) {
                    if($value["status"]=="pending"){
                        $st_com=false;
                    }
                }

                if($st_com){
                    echo $this->ir_compressimg2();
                }
            }
                
            }

    }


    function ir_compressimg() {

                    if(file_exists(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/status_opt.txt")){
                        $var__=file_get_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/status_opt.txt");
                    }else{
                        $var__="not";
                        file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/status_opt.txt",$var__);                        
                        return false;
                    }

                    if($var__=="not"){

                        $totalsize = 0;
                        // Images Array 
                        $ir_images = [];
                        $imageCounter = 0;

                        $path = wp_upload_dir()["basedir"];
                        $b = strpos($path, 'wp-content/')+11;
                        $path = substr($path,0,$b);
                        $this->ir_custom_images_iterator($path,$ir_images,$totalsize,$imageCounter);

                        $optImgCount = $this->ir_get_opt_img_count();
                        $optImgCount =$optImgCount>$imageCounter ? $imageCounter:$optImgCount;

                        if($optImgCount>=round($imageCounter/4)){
                            $optImgCount=round($imageCounter/4);
                        }
                        if(file_exists(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls3.txt")){
                            $var__=file_get_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls3.txt");
                            $var__=preg_replace( "/\r|\n/", "", $var__ );
                            $var__=explode("_ir_",$var__);
                            $counturl=[];
                            $counurk__=0;
                            foreach ($var__ as $var__key => $var__value) {

                                if(!empty(preg_replace("/\s+/", "", $var__value))){
                                    $counturl[$var__value]=$var__value;    
                                    $counurk__++;
                                }
                                
                            }
                            $optImgCount=count($counturl);

                            if($optImgCount>=1000 && !$this->ir_check_feature_pre()){
                                $optImgCount = 1000;
                            }

                        }

                        if($optImgCount<round($imageCounter/4)){
                            $GLOBALS['progressbar_show']="show";
                            $ir_form_data = get_user_meta(1);
                            $ir_optimize_level = $ir_form_data["ir_optimize_level"][0] ?? 40 ;
                            $ir_optimize_level = (int) $ir_optimize_level;
                            $img_to_webp_ir = $ir_form_data["ir_to_webp"][0] ?? 1;
                            $img_to_webp_ir = $img_to_webp_ir == 1 ? true : false;
                            // Form Data End
                            if(!$this->ir_check_feature_pre()){
                                $img_to_webp_ir = false;
                            }

                            $ir_images2 = $this->ir_get_images_to_optimize_urls($img_to_webp_ir,$ir_optimize_level);
                            $total = count($ir_images2);
                            $count_=0;
                            foreach($ir_images as $key=>$images){
                                if(is_array($images)){
                                    foreach($images as $image){
                                        $image = str_replace("\\","/",$image);
                                        $image = stripslashes($image);
                                        // Checking if exists in json db
                                        $path = substr($image,0,strrpos($image,"/"));
                                        $filename = substr($image,strrpos($image,"/")+1);
                                        if($this->ir_is_image($filename)){
                                            if(file_exists($image)){    


                                                if(!in_array($image, $var__)){
                                                    
                                                    @$count_++;
                                                    @$url=$path."/".$filename;
                                                    // $this->ir_compressor();
                                                    @$url_2=$url;
        @$filename = substr(strrchr($url, '/'), 1);
        @$year=str_replace("/".$filename,"",$url);
        @$year=explode("uploads/",$year)[1];
        @$month=explode("/",$year)[1];
        @$year=explode("/",$year)[0];

        $year_="";
        if($year!=""){
            $year_=$year;
        }

        $month_="";
        if($month!=""){
            $month_=$month;
        }

        global $wpdb;
    $table_name = $wpdb->prefix . 'gowebp';
   
   $checkIfExists = $wpdb->get_var("SELECT ID FROM $table_name WHERE url = '$url_2'");

    if ($checkIfExists == NULL) { 

    $wpdb->insert( 
        $table_name, 
        array( 
            'url' => $url_2, 
            'name' => $filename, 
            'year' => $year_, 
            'month' => "ahsan2", 
        ) 
    );
    
}

                                                    @$var__2=file_get_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls3.txt");
                                                    $var__2=$var__2.$url."_ir_\n";
                                                    file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls3.txt",$var__2);
                                                    // file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/gowebp_urls5.txt",$var__2);
                                                }


                                                
                                            }
                                        }
                                        
                                        
                                    }
                                }
                            }
                             // $this->ir_compressimg2();
                            file_put_contents(dirname(plugin_dir_path(__FILE__))."/gowebp/includes/status_opt.txt","completed");
                            echo "completed";
                        }else{
                            echo "completed";
                        }

                    }
          

    }

}

$store = new GoWEBP_STORE;




add_action( 'wp_ajax_nopriv_ir_compressimg',  [$store, "ir_compressimg4"] );
add_action( 'wp_ajax_ir_compressimg',[$store, "ir_compressimg4"] );

add_action( "wp_ajax_irOptimizeAjax", [$store, "irOptimizeAjax"]); 
add_action( "wp_ajax_irStartOptimization", [$store, "ir_start_optimization"]); 
add_action( "wp_ajax_ir_submit", [$store, "ir_get_key"]);
add_action( "wp_ajax_ir_handle_error", [$store, "ir_handle_error"]);

add_action('wp_ajax_ir_get_img_stats',[$store, 'ir_get_img_stats']); 
add_action('wp_ajax_subscription_details',[$store, 'ir_sub_details']); 
add_action('wp_ajax_unsubscribe_request',[$store, 'ir_unsubscribe']); 

add_action('wp_ajax_external_url_add',[$store, 'ir_external_url_add']); 
add_action('wp_ajax_loadExternalUrls',[$store, 'loadExternalUrls']); 
add_action('wp_ajax_delExternalUrls',[$store, 'delExternalUrls']); 

add_action('wp_ajax_ir_add_custom_img_path',[$store, 'ir_add_custom_img_path']); 
add_action('wp_ajax_load_custom_paths',[$store, 'load_custom_paths']); 
add_action('wp_ajax_del_custom_paths',[$store, 'del_custom_paths']); 

add_action('wp_ajax_ir_check_opt_progresss',[$store, 'ir_check_opt_progresss']); 
