<?php
require_once(dirname(__FILE__).'/vendor/autoload.php');
require_once(dirname(__FILE__).'/includes/helper.php');
require_once(dirname(__FILE__).'/gowebp_worker.php');
require_once(dirname(__FILE__).'/store.php');
use DirectoryIterator;
class GoWEBP_Revert extends GOWEBP_WORKER{
    function ir_revert_gowebp(){
        global $wpdb;

        $table_name = $wpdb->prefix . "gowebp"; 

$sql = "DROP TABLE $table_name";

require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
dbDelta( $sql );

global $wpdb;
$delete = $wpdb->query("TRUNCATE TABLE $table_name");
$delete = $wpdb->query("Drop TABLE $table_name");

        $dir = WP_CONTENT_DIR.'/_gowebp_/';
        $dir2 = wp_upload_dir()["basedir"].'/litespeed/';
        $dir3=WP_CONTENT_DIR."/cache";
        $dir4=WP_CONTENT_DIR."/litespeed";
            $this->ir_empty_dir($dir);
            $this->ir_empty_dir($dir2);
            $this->ir_empty_dir($dir3);
            $this->ir_empty_dir($dir4);
        $this->ir_delete_metas();
        $this->ir_revert_theme_images();
        setcookie('ir_cookie_stats', null, -1, '/'); 
        setcookie('ir_cookie_stats2', null, -1, '/'); 
        
    }
    function ir_empty_dir($path){
        if(is_dir($path)){

        
        $dir = new DirectoryIterator($path);
        
        foreach($dir as $file){
            if(!$file->isDot()){
                if(!$file->isDir()){
                    @unlink($file->getPathname());
                }else{
                    $this->ir_empty_dir($file->getPathname());
                    @rmdir($file->getPathname());
                }
            }
        }
        @rmdir($path);
        }

    }
    
    function ir_delete_metas(){
        $ir_metas = ["ir_shadow_size","ir_shadow_color", "ir_shadow_opacity", "ir_image_shadow", "ir_desktop_dimension"
        , "ir_total_images_size_before", "ir_thumbnail_dimension", "ir_mobile_dimension", "ir_tablet_dimension"
        , "ir_optimized_image_count", "ir_reOptimize", "ir_border_status", "ir_border_status", "ir_progload_status"
        , "ir_viewport_status", "ir_start_optimization", "ir_to_webp", "ir_optimize_level", "border_radius"
        ,"border_color", "border_size", "ir_theme_image_status","ir_start_date","ir_original_img_count","ir_end_date"
        ,"ir_gowebp_status","ir_features_status","ir_done_opt_prog","ir_total_opt_prog","border_on_post","border_on_featured"
        ,"border_on_thumbnail","shadow_on_post","shadow_on_featured","shadow_on_thumbnail","ir_exif_status","ir_url_insert_date"
        ,"ir_pay_plan","ir_pay_method","ir_limit_reached","ir_limit_reached"];
    
        foreach($ir_metas as $meta){
            delete_user_meta(1,$meta);
        }
    }
    
    function ir_revert_theme_images(){
        $theme_images = $this->ir_get_theme_images_url();
        foreach($theme_images as $image){
            if(strpos($image,"_ir_img_original")){
                $old_name = str_replace("_ir_img_original","",$image);
                rename($image,$old_name);
            }
        }
    }
    
    // Revert Functions End
}


$uninstall = new GoWEBP_Revert;
$uninstall->ir_revert_gowebp();