<?php
if ( ! defined( 'ABSPATH' ) ) exit;
// $server = $_SERVER["SERVER_NAME"];
if(!$gowebp_ir->ir_check_server() && $gowebp_ir->ir_check_active()){
    
    $ir_form_data = get_user_meta(1);
    $optimize_progress = $ir_form_data["ir_reOptimize"][0] ?? 0;
    $optimize_started = $ir_form_data["ir_start_optimization"][0] ?? 0;
    $amp_status = $gowebp_ir->getAmpStatus() ? 'checked' : '';

    $ir_to_webp = $ir_form_data["ir_to_webp"][0] ?? 1;
    // $ir_to_webp = $ir_form_data["ir_features_status"][0] ?? "trial";
    $ir_to_webp = $ir_to_webp==1 ? "checked" : "";
    $deeee = "";
    $d_label = "";
    $display="display:none;";
    $remaining_days = $gowebp_ir->ir_get_remaining_days();
    $status =$gowebp_ir->ir_check_feature_pre(); 
    if(!$status){
        $ir_to_webp = "";
        $deeee = "disabled";
        $d_label = "disabled_label";
        $display = "";
    }
    $ir_to_legacy = $ir_to_webp=="" ? "checked" : "";
    
    $ir_theme_image_status  = $ir_form_data["ir_theme_image_status"][0] ?? 0;
    $ir_theme_image_status  = $ir_theme_image_status ==1 ? "checked" : "";


    $ir_optimize_level = isset($ir_form_data["ir_optimize_level"][0]) ? 100 - (int)$ir_form_data["ir_optimize_level"][0] : 40;

    $ir_border_status = $ir_form_data["ir_border_status"][0] ?? 0;
    $ir_border_status = $ir_border_status == 0 ? "" : "checked";

    $ir_exif_status = $ir_form_data["ir_exif_status"][0] ?? 0;
    $ir_exif_status = $ir_exif_status == 0 ? "" : "checked";

    $ir_viewport_status = $ir_form_data["ir_viewport_status"][0] ?? 1;
    $ir_viewport_status = $ir_viewport_status == 0? "":"checked";

    $ir_progload_status = $ir_form_data["ir_progload_status"][0] ?? 1;
    $ir_progload_status = $ir_progload_status == 1 ? "checked" : "";

    $ir_premi_status = $ir_form_data["ir_features_status"][0] ?? 'trial';
    $ir_premi_status = $ir_premi_status == 'trial' ? 'disabled' : '';

    $err_class = $ir_premi_status == 'disabled' ? 'err_trigger_class' : '';

    $border_size = $ir_form_data["border_size"][0] ?? "0";
    $border_color = $ir_form_data["border_color"][0] ?? "#000000";
    $border_radius = $ir_form_data["border_radius"][0] ?? "5";

    $border_on_thumbnail  = $ir_form_data["border_on_thumbnail"][0] ?? 1;
    $border_on_thumbnail  = $border_on_thumbnail ==1 ? "checked" : "";
    $border_on_featured  = $ir_form_data["border_on_featured"][0] ?? 1;
    $border_on_featured  = $border_on_featured ==1 ? "checked" : "";
    $border_on_post  = $ir_form_data["border_on_post"][0] ?? 1;
    $border_on_post  = $border_on_post ==1 ? "checked" : "";

    $desktop_dimension = isset($ir_form_data["ir_desktop_dimension"][0])? 100-(int)$ir_form_data["ir_desktop_dimension"][0] : 25;
    $desktop_dimension = isset($ir_form_data["ir_desktop_dimension"][0])? 100-(int)$ir_form_data["ir_desktop_dimension"][0] : 0;
    $tablet_dimension = isset($ir_form_data["ir_tablet_dimension"][0]) ? 100-(int)$ir_form_data["ir_tablet_dimension"][0] : 0;
    $mobile_dimension = isset($ir_form_data["ir_mobile_dimension"][0]) ? 100-(int)$ir_form_data["ir_mobile_dimension"][0] : 0;
    $thumbnail_dimension = isset($ir_form_data["ir_thumbnail_dimension"][0]) ? 100-(int)$ir_form_data["ir_thumbnail_dimension"][0] : 80;
    
    
    
    $ir_shadow_status = $ir_form_data["ir_image_shadow"][0] ?? 0;
    $ir_shadow_status = $ir_shadow_status == 0 ? "" : "checked";

    $shadow_size = $ir_form_data["ir_shadow_size"][0] ?? "10";

    $shadow_color = $ir_form_data["ir_shadow_color"][0] ?? "#000000";
    $shadow_opacity = $ir_form_data["ir_shadow_opacity"][0] ?? "0.5";

    $shadow_on_thumbnail  = $ir_form_data["shadow_on_thumbnail"][0] ?? 1;
    $shadow_on_thumbnail  = $shadow_on_thumbnail ==1 ? "checked" : "";
    $shadow_on_featured  = $ir_form_data["shadow_on_featured"][0] ?? 1;
    $shadow_on_featured  = $shadow_on_featured ==1 ? "checked" : "";
    $shadow_on_post  = $ir_form_data["shadow_on_post"][0] ?? 1;
    $shadow_on_post  = $shadow_on_post ==1 ? "checked" : "";

    // For Redirecting to optimization tab
    $show_success = "false";
    if(isset($_GET["reg_success"])){
        $show_success = "true";
    }
    
    $domain = sanitize_text_field( $_SERVER["HTTP_HOST"] );
    $domain = str_replace(['http://','https://','www.'],'',$domain);
    
    
    $amp_msg = "(Not-supported for AMP)";

?>


 <style>
    
     #wpfooter{
         position:static;
     }
     .wrap{
         overflow-x:hidden;
         font-family: 'Raleway', sans-serif;
     }

     .ir_total{
        padding-right:40px;
        font-size:18px;
     }
     .ir_total span{
        /*font-weight:bold;*/

     }
    .ir_section_divider{
        width: 90%;
        background: #959393;
        height: 2px;
        opacity: 0.6;
        border-radius: 368%;
        /*margin-left: auto;*/
        margin-right: auto;
        margin-top:5px;
        margin-bottom:10px;
    }
    .ir_progress_loader{
        width: 90%;
        margin-left: auto;p
        margin-right: auto;
        margin-top:5px;
        margin-bottom:10px;
        display:none;
    }
.stage{
    display:flex;
    width:100%;
    height:100%;
    justify-content:center;
    align-items:center;
    padding:10px;
}
.dot-flashing {
  position: relative;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color:black;
  color:black;
  animation: dotFlashing 1s infinite linear alternate;
  animation-delay: .5s;
}

.dot-flashing::before, .dot-flashing::after {
  content: '';
  display: inline-block;
  position: absolute;
  top: 0;
}

.dot-flashing::before {
  left: -15px;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color:black;
  color:black;
  animation: dotFlashing 1s infinite alternate;
  animation-delay: 0s;
}

.dot-flashing::after {
  left: 15px;
  width: 10px;
  height: 10px;
  border-radius: 5px;
  background-color:black;
  color:black;
  animation: dotFlashing 1s infinite alternate;
  animation-delay: 1s;
}

@keyframes dotFlashing {
  0% {
    background-color:black;
  }
  50%,
  100% {
    background-color: #ebe6ff;
  }
}

/* Dot Loader End */


/* Percentage Loader Start */
.circlePercent {
  position: absolute;
    top: -12px;
    left: 15px;
    width: 67.2px;
    height: 67.2px;
    border-radius: 50%;
    background: var(--loaderColor);
}
.circlePercent:before,
.circlePercent > .progressEnd {
  position: absolute;
    z-index: 3;
    top: 1px;
    left: 36px;
    width: 0px;
    height: 0px;
    border-radius: 50%;
    background: var(--loaderTrack);
    -ms-transform-origin: 3px 46px;
    transform-origin: 3px 32.2px;
    content: "";
}
.circlePercent:after,
.circlePercent > .progress {
    position: absolute;
    -ms-transform-origin: 33.6px 33.6px;
    transform-origin: 33.6px 33.6px;
    z-index: 0;
    top: 0;
    left: 0;
    width: 33.6px;
    height: 67.2px;
    border-radius: 33.6px 0 0 33.6px;
    background: var(--loaderColor);
    content: "";
}
.circlePercent.fiftyPlus:after {
  background: white;
  -ms-transform: rotate(180deg);
  transform: rotate(180deg);
}
.circlePercent > .progress.progress {
  background: white;
}
.circlePercent > .counter {
  position: absolute;
    box-sizing: border-box;
    z-index: 2;
    width: 70px;
    height: 70px;
    margin-top: -1px;
    margin-left: -1px;
    border-radius: 50%;
    /* border: 4px solid var(--loaderColor); */
    border: 4px solid #e2e1e1;
  
}
.circlePercent > .counter:before {
  position: absolute;
  z-index: 1;
  top: 50%;
  margin-top: -13px;
  width: 105%;
  height: 26px;
  font-size: 18px;
  line-height: 24px;
  font-family: sans-serif;
  text-align: center;
  color: white;
  content: attr(data-percent) "%";
}
.circlePercent > .counter:after {
  position: absolute;
  width: 55px;
  height: 55px;
  top: 3px;
  left: 3px;
  border-radius: 50%;
  background: var(--loaderColor);
  content: "";
}
.circlePercent > .counter[data-percent="100"] {
  background: white;
}
/* Percentage Loader End */

td{
    padding-top:10px
}

/* New Range Start */
.range-slider.grad {
  --progress-shadow: 2px 2px 4px rgba(0, 0, 0, 0.2) inset;
  --progress-flll-shadow: var(--progress-shadow);
  /* --fill-color: linear-gradient(to right,#fffc00 20%, #00d119 50%, orange 80%, red 90%); */
  --fill-color: linear-gradient(to right,#fffc00 -15%, #00d119 60%,orange 66%, red 95%);
  --thumb-shadow: 0 0 4px rgba(0, 0, 0, 0.3),
    -3px 9px 9px rgba(255, 255, 255, 0.33) inset,
    -1px 3px 2px rgba(255, 255, 255, 0.33) inset,
    0 0 0 99px var(--primary-color) inset;
}
.range-slider.grad input:hover {
  --thumb-transform: scale(1.2);
}
.range-slider.grad input:active {
  --thumb-shadow: inherit;
  --thumb-transform: scale(1);
}
.range::-webkit-slider-thumb{
    background: #fff;

}

.range-slider.flat {
  --thumb-size: 25px;
  --track-height: calc(var(--thumb-size) / 3);
  --progress-shadow: none;
  --progress-flll-shadow: none;
  --thumb-shadow: 0 0 0 7px var(--primary-color) inset, 0 0 0 99px white inset;
  --thumb-shadow-hover: 0 0 0 9px var(--primary-color) inset,
    0 0 0 99px white inset;
  --thumb-shadow-active: 0 0 0 13px var(--primary-color) inset;
}

.range-slider.overlay {
  --primary-color: #d6e9ff;
  --track-height: 50px;
  --thumb-size: var(--track-height);
  --thumb-color: var(--primary-color);
  --thumb-shadow: none;
  --progress-flll-shadow: none;
  --progress-shadow: none;
  --progress-background: none;
  --progress-radius: 0px;
  --ticks-color: var(--primary-color);
  --ticks-height: 0;
  --ticks-thickness: 0;
  --ticks-gap: 0px;
  --min-max-font: 700 18px Arial;
  --min-max-opacity: 1;
  --show-min-max: none;
  color: #0366d6;

}
.range-slider.overlay input:hover {
  --thumb-shadow: calc(25px - (50px * var(--is-left-most))) 0 0 -15px #0366d6
    inset;
}
.range-slider.overlay input:active {
  --thumb-color: inherit;
}
.range-slider.overlay .range-slider__values {
  width: calc(100% - 50% / (var(--max) - var(--min)));
}

.range-slider {
  --primary-color: white;
  --value-offset-y: var(--ticks-gap);
  --value-active-color: white;
  --value-background: transparent;
  --value-background-hover: var(--primary-color);
  --value-font: 700 12px/1 Arial;
  --fill-color: var(--primary-color);
  --progress-background: #eee;
  --progress-radius: 20px;
  --track-height: calc(var(--thumb-size) / 2);
  --min-max-font: 12px Arial;
  --min-max-opacity: 0.5;
  --min-max-x-offset: 10%;
  --thumb-size: 22px;
  --thumb-color: white;
  --thumb-shadow: 0 0 10px rgba(0, 0, 0, 0.6),
    0 0 0 99px var(--thumb-color) inset;
  --thumb-shadow-active: 0 0 0 calc(var(--thumb-size) / 4) inset
      var(--thumb-color),
    0 0 0 99px var(--primary-color) inset, 0 0 3px rgba(0, 0, 0, 0.4);
  --thumb-shadow-hover: var(--thumb-shadow);
  --ticks-thickness: 1px;
  --ticks-height: 5px;
  --ticks-gap: var(
    --ticks-height,
    0
  );
  --ticks-color: silver;
  --step: 1;
  --ticks-count: Calc(var(--max) - var(--min)) / var(--step);
  --maxTicksAllowed: 30;
  --too-many-ticks: Min(1, Max(var(--ticks-count) - var(--maxTicksAllowed), 0));
  --x-step: Max(
    var(--step),
    var(--too-many-ticks) * (var(--max) - var(--min))
  );
  --tickInterval: 100/ ((var(--max) - var(--min)) / var(--step)) * var(--tickEvery, 1);
  --tickIntervalPerc: calc(
    (100% - var(--thumb-size)) / ((var(--max) - var(--min)) / var(--x-step)) *
      var(--tickEvery, 1)
  );
  --value-a: Clamp(
    var(--min),
    var(--value, 0),
    var(--max)
  );
  --value-b: var(--value, 0);
  --text-value-a: var(--text-value, "");
  --completed-a: calc(
    (var(--value-a) - var(--min)) / (var(--max) - var(--min)) * 100
  );
  --completed-b: calc(
    (var(--value-b) - var(--min)) / (var(--max) - var(--min)) * 100
  );
  --ca: Min(var(--completed-a), var(--completed-b));
  --cb: Max(var(--completed-a), var(--completed-b));
  --thumbs-too-close: Clamp(
    -1,
    1000 * (Min(1, Max(var(--cb) - var(--ca) - 5, -1)) + 0.001),
    1
  );
  --thumb-close-to-min: Min(1, Max(var(--ca) - 2, 0));
  --thumb-close-to-max: Min(1, Max(98 - var(--cb), 0));
  display: inline-block;
  height: max(var(--track-height), var(--thumb-size));
  background: linear-gradient(to right, var(--ticks-color) var(--ticks-thickness), transparent 1px) repeat-x;
  background-size: var(--tickIntervalPerc) var(--ticks-height);
  background-position-x: calc( var(--thumb-size) / 2 - var(--ticks-thickness) / 2 );
  background-position-y: var(--flip-y, bottom);
  padding-bottom: var(--flip-y, var(--ticks-gap));
  padding-top: calc(var(--flip-y) * var(--ticks-gap));
  position: relative;
  z-index: 1;
}
.range-slider[data-ticks-position=top] {
  --flip-y: 1;
}

.range-slider__values {
  position: relative;
  top: 50%;
  line-height: 0;
  text-align: justify;
  width: 100%;
  pointer-events: none;
  margin: 0 auto;
  z-index: 5;
}
.range-slider__progress {
  --start-end: calc(var(--thumb-size) / 2);
  --clip-end: calc(100% - (var(--cb)) * 1%);
  --clip-start: calc(var(--ca) * 1%);
  --clip: inset(-20px var(--clip-end) -20px var(--clip-start));
  position: absolute;
  left: var(--start-end);
  right: var(--start-end);
  top: calc( var(--ticks-gap) * var(--flip-y, 0) + var(--thumb-size) / 2 - var(--track-height) / 2 );
  height: calc(var(--track-height));
  background: var(--progress-background, #eee);
  pointer-events: none;
  z-index: -1;
  border-radius: var(--progress-radius);
}
.range-slider__progress::before {
  content: "";
  position: absolute;
  left: 0;
  right: 0;
  -webkit-clip-path: var(--clip);
          clip-path: var(--clip);
  top: 0;
  bottom: 0;
  background: var(--fill-color, black);
  box-shadow: var(--progress-flll-shadow);
  z-index: 1;
  border-radius: inherit;
}
.range-slider__progress::after {
  content: "";
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  box-shadow: var(--progress-shadow);
  pointer-events: none;
  border-radius: inherit;
}
.range-slider > input {
  -webkit-appearance: none;
  width: 100%;
  height: var(--thumb-size);
  margin: 0;
  position: absolute;
  left: 0;
  cursor: -webkit-grab;
  cursor: grab;
  outline: none;
  background: none;
}
.range-slider > input:not(:only-of-type) {
  pointer-events: none;
}
.range-slider > input::-webkit-slider-thumb {
  -webkit-appearance: none;
          appearance: none;
  height: var(--thumb-size);
  width: var(--thumb-size);
  transform: var(--thumb-transform);
  border-radius: var(--thumb-radius, 50%);
  background: var(--thumb-color);
  box-shadow: var(--thumb-shadow);
  border: none;
  pointer-events: auto;
  -webkit-transition: 0.1s;
  transition: 0.1s;
}
.range-slider > input::-moz-range-thumb {
  -moz-appearance: none;
       appearance: none;
  height: var(--thumb-size);
  width: var(--thumb-size);
  transform: var(--thumb-transform);
  border-radius: var(--thumb-radius, 50%);
  background: var(--thumb-color);
  box-shadow: var(--thumb-shadow);
  border: none;
  pointer-events: auto;
  -moz-transition: 0.1s;
  transition: 0.1s;
}
.range-slider > input::-ms-thumb {
  appearance: none;
  height: var(--thumb-size);
  width: var(--thumb-size);
  transform: var(--thumb-transform);
  border-radius: var(--thumb-radius, 50%);
  background: var(--thumb-color);
  box-shadow: var(--thumb-shadow);
  border: none;
  pointer-events: auto;
  -ms-transition: 0.1s;
  transition: 0.1s;
}
.range-slider > input:hover {
  --thumb-shadow: var(--thumb-shadow-hover);
}
.range-slider > input:hover + output {
  --value-background: var(--value-background-hover);
  --y-offset: -5px;
  color: var(--value-active-color);
  box-shadow: 0 0 0 3px var(--value-background);
}
.range-slider > input:active {
  --thumb-shadow: var(--thumb-shadow-active);
  cursor: -webkit-grabbing;
  cursor: grabbing;
  z-index: 2;
}
.range-slider > input:active + output {
  transition: 0s;
}
.range-slider > input:nth-of-type(1) {
  --is-left-most: Clamp(0, (var(--value-a) - var(--value-b)) * 99999, 1);
}
.range-slider > input:nth-of-type(1) + output {
  --value: var(--value-a);
  --x-offset: calc(var(--completed-a) * -1%);
}
.range-slider > input:nth-of-type(1) + output:not(:only-of-type) {
  --flip: calc(var(--thumbs-too-close) * -1);
}
.range-slider > input:nth-of-type(1) + output::after {
  content: var(--prefix, "") var(--text-value-a) var(--suffix, "");
}
.range-slider > input:nth-of-type(2) {
  --is-left-most: Clamp(0, (var(--value-b) - var(--value-a)) * 99999, 1);
}
.range-slider > input:nth-of-type(2) + output {
  --value: var(--value-b);
}
.range-slider > input:only-of-type ~ .range-slider__progress {
  --clip-start: 0;
}
.range-slider > input + output {
  --flip: -1;
  --x-offset: calc(var(--completed-b) * -1%);
  --pos: calc(
    ((var(--value) - var(--min)) / (var(--max) - var(--min))) * 100%
  );
  pointer-events: none;
  position: absolute;
  z-index: 5;
  background: var(--value-background);
  border-radius: 10px;
  padding: 2px 4px;
  left: var(--pos);
  transform: translate(var(--x-offset), calc( 150% * var(--flip) - (var(--y-offset, 0px) + var(--value-offset-y)) * var(--flip) ));
  transition: all 0.12s ease-out, left 0s;
}

.range-slider,
label[dir=rtl] .range-slider {
  width: clamp(300px, 50vw, 800px);
  min-width: 180px;
}
/* New Range End */

.btn-submit{
    background: var(--ir-green-hover) !important;
    background-color: var(--ir-green) !important;
    color: #fff;
}

.btn-submit:hover{
    color: #fff !important;
    background: green !important;
    box-shadow: 1px 1px 5px rgba(0,0,0,0.5);

}
.btn-submit:focus{
    box-shadow:  1px 1px 7px rgba(122, 0, 153, 0.5)

}

.fa-info-circle{
    color: rgba(0,0,0,0.4);
    opacity:0.5;
}
.fa-info-circle:hover{
    opacity:1;

}


/* Registration Loader Start*/
.loader-register {
  border: 8px solid #f3f3f3;
  border-radius: 50%;
  border-top: 8px solid #2d3436;
  width: 40px;
  height: 40px;
  -webkit-animation: spin 2s linear infinite; /* Safari */
  animation: spin 2s linear infinite;
}

/* Safari */
@-webkit-keyframes spin {
  0% { -webkit-transform: rotate(0deg); }
  100% { -webkit-transform: rotate(360deg); }
}

@keyframes spin {
  0% { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}


.reg_form_div{
    flex-grow:1;
}
@media screen and (min-width: 800px){
    .reg_form_div{
        margin-left:10%;
    }
}

.get_key_link{
    height: 100%;
    padding-top: 20px;  
    margin-left: 10px;  
    width: 100%;
}
.get_key_div{
    width: 100px;
    margin-right: -20px;
    margin-left: 20px;
    background: #dcdcde;
}
@media screen and (max-width: 700px){
    .get_key_link{
        padding-top: 10px;
        margin-left: 0px
    }
    .get_key_div{
        width: 100%;
        margin-top:6px;
        margin-right: 0;
        margin-left: 0;
    }
    .reg_form_div{
        margin-top:10px;
    }
}

.err_class{
    opacity:0.6;
     font-weight: 900;
     padding-left:10px; 
     white-space:nowrap;
     color:#eb4d4b;
     font-size:13px;
     margin-top:6px;
     display:none;
}
.btn-key{
    background: #ff5e5c;
    color: white;
}
.btn-key:hover{
    background: #eb4d4b;
    color: white;
}

.amp_support{
     opacity:0.4;
     font-weight: 900;
     /*padding-left:10px; */
     white-space:nowrap;
     font-size:13px;
     margin-top:8px;
}

@media screen and (max-width:540px){
    .amp_support{
        font-size:10px;
    }
}
@media (min-width: 1200px){
    .container, .container-lg, .container-md, .container-sm, .container-xl {
        max-width: 1200px;
    }
}
/* Registration Loader End*/

/*Preview Image*/
#previewImage{
    background: url(<?=plugin_dir_url(__FILE__) ?>/lib/img/preview.png);
    min-height: 511px;
    box-shadow: none;
    background-repeat: no-repeat;
}
@media (max-width: 766px){
    #previewImage {
         background: url(<?=plugin_dir_url(__FILE__) ?>/lib/img/mobile_preview.png);
         min-height: 511px;
         background-repeat: no-repeat;
    }
/*Preview Image End*/
    .wrap .ftco-section form table tr td{
        display:grid;
    }
    .wrap .ftco-section .t-cell{
        display:table-cell !important;
    }
    .wrap .ftco-section .t-cell input{
        margin-left:-20px !important;
    }
    .t-value{
        margin-top:-12px !important;
        margin-left:10px;
    }
    
}

.mw-75{
    max-width:75px;
}

.p-2{
    padding: 0.35rem !important;
}
.fa-info-circle:before{
    padding-left:10px;
}

#myloader1{
  display: none;
}
.lds-ellipsis {
  display: inline-block;
  position: relative;
  width: 80px;
  height: 80px;
}
.lds-ellipsis div {
  position: absolute;
  top: 33px;
  width: 13px;
  height: 13px;
  border-radius: 50%;
  background: #00d119;
  animation-timing-function: cubic-bezier(0, 1, 1, 0);
}
.lds-ellipsis div:nth-child(1) {
  left: 8px;
  animation: lds-ellipsis1 0.6s infinite;
}
.lds-ellipsis div:nth-child(2) {
  left: 8px;
  animation: lds-ellipsis2 0.6s infinite;
}
.lds-ellipsis div:nth-child(3) {
  left: 32px;
  animation: lds-ellipsis2 0.6s infinite;
}
.lds-ellipsis div:nth-child(4) {
  left: 56px;
  animation: lds-ellipsis3 0.6s infinite;
}
@keyframes lds-ellipsis1 {
  0% {
    transform: scale(0);
  }
  100% {
    transform: scale(1);
  }
}
@keyframes lds-ellipsis3 {
  0% {
    transform: scale(1);
  }
  100% {
    transform: scale(0);
  }
}
@keyframes lds-ellipsis2 {
  0% {
    transform: translate(0, 0);
  }
  100% {
    transform: translate(24px, 0);
  }
}

 </style>
<div class="wrap" id="ir_blur">
<div class="bg-light justify-content-start p-3 s003">
    <div>
        <img src="<?=plugin_dir_url( __FILE__ )."lib/img/icon-big.png" ?>" width=70 />  
        <span style="font-size:25px;font-weight:700;position:relative;top:4px" > GOWEBP</span>
    </div>
<!-- Registration Form Start -->
<div style="<?=$display?>" class="reg_form_div">
<!--<div  class="reg_form_div">-->
    <form id="reg_form">
      <input type="hidden" name="action" value="ir_submit" >
      <?php wp_nonce_field( 'ir_reg_form_submit', 'ir_reg_form_nonce' );?>
      <div class="inner-form">
        <div class="input-field second-wrap">
          <input id="search" name="reg_key" type="text" placeholder="Enter Registeration Key" />
        </div>
        <div id="sub" class="input-field third-wrap">
          <button type="submit"  id="reg_sub" class="btn-search" type="button">
              <strong> Reigster </strong>
            </button>        
            
        </div>
        <div class="input-field get_key_div">
          <a href="https://gowebp.com/checkout.php?plan=monthly&domain=<?=$domain ?>" target="_blank" class="btn btn-key get_key_link" >
              <strong> Get Key </strong>
          </a>
        </div>
      </div>
    </form>
  </div>
  <!-- Registration Form End -->
</div>
    <div>
        <section class="ftco-section">
            <div class="container">
                <!-- General Settings Tab Start -->
            <div class="row <?php if(!$status){ ?> justify-content-center <?php } ?>">
				<div class="col-md-12">
					<div class="wrapper">
						<div class="row no-gutters">
                        <form id="optimizeMe" class="col-md-8">

                        <?php
                        do_settings_sections( "ir_optimization" );
                        settings_fields( "ir_optimization" );
                        ?> 
                        <input type="hidden" name="action" value="irOptimizeAjax">

								<div class="contact-wrap w-100">
									<h3 class="mb-2">Optimization Settings</h3>
                                <div class="ir_section_divider"></div>
                                <div>
                                <h5 style="font-size:18px;font-wegiht:900px">Image Format</h5>
                                    <ul>
                                        <li>
                                        <input type="radio" id="s-option"  name="ir_to_webp" value="0" <?=$ir_to_legacy?> >
                                        <label for="s-option">Legacy <span style="opacity:0.6"> (e.g. jpg | jpeg | png | gif)</span></label>
                                        <div class="check"><div class="inside"></div></div>
                                        </li>
                                        <li class="d-flex nowrap">
                                        <input type="radio" id="f-option" name="ir_to_webp"  value="1" <?=$deeee?> <?=$ir_to_webp ?>>
                                        <label class="<?=$err_class." ".$d_label ?>" for="f-option">Webp</label>
                                        
                                        <div class="check <?=$deeee?>"></div>
                                        <span class="err_class" style="<?=$display ?>"> For Paid Version!</span>
                                        </li>
                                    </ul>
                                </div>
                                <div style="clear:both"></div>
                                    <div class="d-flex align-items-center py-2">
                                        <h5 style="padding-right:40px;font-size:18px;">Opt lvl</h5>
                                                <div id="rangePath" class="range-slider grad" style='--min:0; --max:10000; --step:100; --value:<?=$ir_optimize_level*100?>; --text-value:"200"; --prefix:"$"; width:260px;'>
                                                    <input name="rangeValOpt" id="rangeValOpt" value="<?=$ir_optimize_level*100?>" type="range" min="0" max="10000" step="500" oninput="this.parentNode.style.setProperty('--value',this.value); this.parentNode.style.setProperty('--text-value', JSON.stringify((+this.value).toLocaleString()))">
                                                    <div class='range-slider__progress'></div>
                                                </div>
                                            <h6 class="pl-2" id="rangePercentOpt"> <?=$ir_optimize_level ?>% </h6> <span data-toggle="tooltip" data-placement="top" title="Default: 65%" class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer"> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                    </div>
                                    <table>
                                    <tr id="viewport_id">
                                        <td><h5 style="padding-right:40px;font-size:18px;">View Port</h5></td>
                                        <td colspan="2" class="d-flex nowrap t-value">
                                        <label class="gowebp-switch">
                                        <input type="checkbox" value="1" name="ir_viewport_status" <?=$ir_viewport_status ?> >
                                        <span class="gowebp-slider round"></span>
                                        </label>
                                        <span data-toggle="tooltip" data-placement="top" title="Request images when its on screen or close to screen." class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                        <span class="amp_support">(AMP Built-in Feature)</span>
                                        </td>
                                        <td>
                                            
                                        </td>
                                    </tr>
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">Progressive Load</h5></td>
                                        <td colspan="2"  class="d-flex nowrap  t-value">
                                        <label class="gowebp-switch">
                                        <input type="checkbox" value="1" name="ir_progload_status" <?=$ir_progload_status ?>>
                                        <span class="gowebp-slider round"></span>
                                        </label>
                                        <span data-toggle="tooltip" data-placement="top" title="Progressive load requests low resolution images at initial i.e: 50x50 then it loads images as per screen size." class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                        <span class="amp_support" ><?=$amp_msg?></span>
                                        </td>
                                        <td>
                                            
                                        </td>

                                    </tr>
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">Theme Images</h5></td>
                                        <td colspan="2" class="d-flex nowrap  t-value">
                                            <label class="gowebp-switch premi_switch <?=$err_class ?>">
                                            <input <?= $ir_premi_status ?> type="checkbox" value="1" name="ir_theme_image_status" <?=$ir_theme_image_status ?>>
                                            <span class="gowebp-slider round"></span>
                                            </label>
                                            <span data-toggle="tooltip" data-placement="top" title="Optimize theme images example: /wp-content/theme" class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                            <span class="err_class"> For Paid Version!</span>
                                        </td>
                                        <td>
                                        </td>

                                    </tr>
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">AMP</h5></td>
                                        <td colspan="2" class="d-flex nowrap  t-value">
                                        <label class="gowebp-switch premi_switch <?=$err_class ?>">
                                        <input <?= $ir_premi_status ?> type="checkbox" value="1" name="ir_amp_status" <?="$amp_status" ?> >
                                        <span class="gowebp-slider round"></span>
                                        </label>
                                        <span data-toggle="tooltip" data-placement="top" title="Serve optimized images on AMP pages." class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> 
                                            <i class="fas fa-info-circle" style="font-size:20px;"></i>
                                        </span>
                                        <span class="err_class" style="<?=$display?>"> For Paid Version!</span>
                                        </td>
                                        <td>
                                        
                                        </td>

                                    </tr>
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">EXIF Data</h5></td>
                                        <td colspan="2" class="d-flex nowrap  t-value">
                                            <label class="gowebp-switch premi_switch <?=$err_class ?>">
                                            <input type="checkbox" value="1" name="ir_exif_status" <?=$ir_exif_status." ".$deeee  ?>>
                                            <span class="gowebp-slider round"></span>
                                            </label>
                                            <span data-toggle="tooltip" data-placement="top" title="EXIF specifies formats of data for images taken by cameras, scanners and other systems handling image." class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                            <span class="err_class" style="<?=$display?>"> For Paid Version!</span>
                                        </td>
                                        <td >
                                        
                                        </td>

                                    </tr>
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">Border </h5></td>
                                        <td colspan="2" class="d-flex nowrap  t-value">
                                        <label class="gowebp-switch">
                                        <input type="checkbox" name="ir_border_status" value="1" <?=$ir_border_status ?>>
                                        <span class="gowebp-slider round"></span>
                                        </label>
                                        <span data-toggle="tooltip" data-placement="top" title="Set image border" class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                        <span class="amp_support" ><?=$amp_msg?></span>
                                        </td>
                                        <td >
                                        
                                        </td>

                                    </tr>
                                    <!-- Border settings -->
                                    <tr class="subBorder">
                                        <td class="t-cell" ><h3 style="padding-right:40px;font-size:14px;">Thickness & Color : </h3></td>
                                        <td class="t-cell">
                                            <input type="number" value="<?=$border_size ?>" max="1000" class='mw-75' name="border_size" /> &nbsp;&nbsp;&nbsp;
                                            <input type="color" name="border_color" value="<?=$border_color?>">
                                        </td>
                                    
                                    </tr>
                                    <tr class="subBorder mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Border Radius : </h3></td>
                                        <td class="t-cell">
                                            <input type="number" name="border_radius" min="0" max="1000" class='mw-75' value="<?=$border_radius?>">
                                        </td>
                                    </tr>
                                    <tr class="subBorder mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Thumbnail Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1"  name="border_on_thumbnail" <?=$border_on_thumbnail ?> >
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="subBorder mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Featured Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1" name="border_on_featured" <?=$border_on_featured ?>>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="subBorder mt-2 ">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Post Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1" name="border_on_post" <?=$border_on_post ?> >
                                        </td>
                                      
                                    </tr>
                                    <!-- Border settings -->

                                    <!-- Shadow Settings -->
                                    <tr>
                                        <td><h5 style="padding-right:40px;font-size:18px;">Image Shadow </h5></td>
                                        <td colspan="2" class="d-flex nowrap  t-value">
                                            <label class="gowebp-switch">
                                                <input type="checkbox" name="ir_image_shadow" value="1" <?= $ir_shadow_status ?>>
                                                <span class="gowebp-slider round"></span>
                                            </label>
                                            <span data-toggle="tooltip" data-placement="top" title="Set image shadow" class="rounded-circle border-0 text-dark t-1 p-2" style="cursor:pointer; "> <i class="fas fa-info-circle" style="font-size:20px;"></i></span>
                                            <span class="amp_support" ><?=$amp_msg ?></span>
                                        </td>
                                        <td >
                                        </td>
                                    </tr>
                                    <tr class="subShadow">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Shadow Size :</h3></td>
                                        <td class="t-cell">
                                            <input type="number" value="<?=$shadow_size ?>" class='mw-75'  name="shadow_size" /> &nbsp;&nbsp;&nbsp;
                                            <input type="color" value="<?=$shadow_color ?>"  name="shadow_color">
                                        </td>
                                    </tr>
                                    <tr class="subShadow mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Shadow Opacity: </h3></td>
                                        <td class="t-cell">
                                            <input type="number" step="0.1" value="<?=$shadow_opacity ?>" class='mw-75' name="shadow_opacity" min="0" max="1" >
                                        </td>
                                    </tr>
                                    <tr class="subShadow mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Thumbnail Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1"  name="shadow_on_thumbnail" <?=$shadow_on_thumbnail ?> >
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="subShadow mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Featured Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1" name="shadow_on_featured" <?=$shadow_on_featured ?>>
                                        </td>
                                        <td></td>
                                    </tr>
                                    <tr class="subShadow mt-2">
                                        <td class="t-cell"><h3 style="padding-right:40px;font-size:14px;">Post Image: </h3></td>
                                        <td class="t-cell">
                                            <input type="checkbox" value="1" name="shadow_on_post" <?=$shadow_on_post ?> >
                                        </td>
                                        <td></td>
                                    </tr>
                                    <!-- Shadow Settings End-->
                                </table>

                                <h6 style="cursor:pointer" id="custom_size" class="text-primary m-1">Advanced Settings <i id="arrow" class="fas fa-caret-down"></i></h6>
                                <div class="m-2" id="custom_size_div" style="display:none">
                                <?php
                                if($deeee !=""){
                                ?>
                                <div class="my-2 text-danger">
                                    <strong>For Paid Version !</strong>
                                </div>
                                <?php
                                }
                                ?>
                                <label class="text-dark">Adjust Image Dimensions as per Device/screen. </label>
                                    <table>
                                        <tr>
                                            <td>Desktop Size</td>
                                            <td><input <?=$deeee ?> min="10" name="ir_desktop_dimension" max="100" type="number" value="<?=$desktop_dimension ?>"></td>
                                            <td style="color:darkblue">&nbsp;%</td>
                                        <tr>
                                            <td>Tablet Size</td>
                                            <td><input <?=$deeee ?> min="10" name="ir_tablet_dimension" max="100" type="number" value="<?=$tablet_dimension ?>"></td>
                                            <td style="color:darkblue">&nbsp;%</td>
                                        <tr>
                                            <td>Mobile Size</td>
                                            <td><input <?=$deeee ?> min="10" name="ir_mobile_dimension" max="100" type="number" value="<?=$mobile_dimension ?>"></td>
                                            <td style="color:darkblue">&nbsp;%</td>
                                        </tr>
                                    </table>
                                    <label for="basic-url" class="text-dark form-label mt-4">Additional/Custom path for images</label>
                                    <div class="d-flex mb-3 ">
                                        <input <?=$deeee ?> type="text" placeholder="/Image-Folder/" id="customPath" class="form-control" id="basic-url1" aria-describedby="basic-addon3" />
                                        <button <?=$deeee ?> class="btn btn-submit ml-2" type="button" id="customPathSubmit" data-mdb-ripple-color="dark">
                                        Add    
                                        </button>
                                    </div>

                                    <!-- Load  Custom Paths -->
                                    <div  class="d-flex justify-content-center">
                                        <div id="pathsLoader" style="display:none;" class="spinner-border text-primary" role="status">
                                            <span class="sr-only">Loading...</span>
                                        </div>
                                    </div>
                                    <div id="loadCustomPath" class="m-2">
                                    </div>

                                </div>
                                <br>
                                <div class="row justify-content-between">
                                    <div class='col-md-8 d-flex'>
                                        <button type="button" style="font-size:20px;box-shadow: 0 4px 2px -2px gray;" id="optimizationFormSubmit" class="btn btn-submit px-3" > <strong> Save & Optimize </strong></button>
                                        <div style="position:relative; margin-top:6px; margin-left:10px;">

                                          <div class="lds-ellipsis" id="myloader1"><div></div><div></div><div></div><div></div></div>
                                        </div>
                                    </div>
                                    <!-- Loader End -->
                                    <div class="col-md-4">
                                        <button class="btn btn-primary" id="default-settings" style="font-size:20px;box-shadow: 0 4px 2px -2px gray;"><strong/> Default Settings &nbsp;</strong></button>
                                    </div>
                                </div>
								</div>
                            </form>
							<div class="col-md-4 bg-white p-2">
                                <div>
                                    <div>
                                        <h3>Status</h3>
                                        <div class="ir_section_divider"></div>
                                        <div>
                                            <label class="ir_total">
                                                Optimized Images:&nbsp;
                                                <span id="total_images_opt"></span> / <span id="total_images"> </span>
                                            </label>
                                            <div id="remaining_images" style="left:-20px" class="dot-flashing mt-2 d-inline-block "></div>
                                        </div>
                                        <?php if(!$status){ ?>
                                        <div>
                                            <label class="ir_total">
                                                Max Optimized Images:&nbsp;
                                                <span style="color:red" > 1000 </span>
                                            </label>
                                        </div>
                                        <?php } ?>
                                        <div>
                                            <label class="ir_total">
                                                Images Size:&nbsp;
                                                <span id="after_img_size"></span> / <span id="before_img_size"></span>
                                            </label>
                                            <div style="left:-20px" class="dot-flashing mt-2 d-inline-block img-count-loader "></div>
                                        </div>
                                        <div>
                                            <label class="ir_total">
                                                Saved Space:&nbsp;
                                                <span id="saved_img_size"></span>
                                            </label>
                                            <div style="left:-20px" class="dot-flashing mt-2 d-inline-block img-count-loader"></div>
                                        </div>
                                        <?php if(!$status){ ?>
                                        <div>
                                            <label class="ir_total">
                                                Remaining Days:&nbsp;
                                                <span style="color:red" > <?=$remaining_days ?> </span>
                                            </label>
                                        </div>
                                        <?php } ?>
                                        
                                        <h3>Preview</h3>
                                        <div class="ir_section_divider" ></div>
                                    </div>
                                    <div id="previewImage" class="w-100 img" >
                                    </div>
			                    </div>
							</div>
						</div>
					</div>
				</div>
			</div>
                    </div>
                    <!-- General Settings End -->
                    
                    <!-- 
                        Tab End ////////////////////////////////////////////////////////////
                     -->
            <!-- Tabs End -->
			
		</div>
	</section>

    </div>


<?php  include_once  dirname(__FILE__) .'/ir_footer.php'; ?>
</div>
<script>


var ir_cookie_stats_ = ir_getCookie("ir_cookie_stats");
var ir_cookie_stats2_ = ir_getCookie("ir_cookie_stats2");
if (ir_cookie_stats_ != "") {                  
  
    document.getElementById("total_images_opt").innerHTML=ir_cookie_stats_;
    document.getElementById("total_images").innerHTML=ir_cookie_stats2_;
  
}


function convertToRGB(hex) {
    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
  if(result){
      var r= parseInt(result[1], 16);
      var g= parseInt(result[2], 16);
      var b= parseInt(result[3], 16);
      return r+","+g+","+b;
    }
}
function round(value, precision) {
    var multiplier = Math.pow(10, precision || 0);
    return Math.round(value * multiplier) / multiplier;
}
// For Loader
function setProgress(elem, percent) {
        var degrees = percent * 3.6,
        transform = /MSIE 9/.test(navigator.userAgent) ? 'msTransform' : 'transform';
        elem.querySelector('.counter').setAttribute('data-percent', Math.round(percent));
        elem.querySelector('.progressEnd').style[transform] = 'rotate(' + degrees + 'deg)';
        elem.querySelector('.progress').style[transform] = 'rotate(' + degrees + 'deg)';
        if(percent >= 50 && !/(^|\s)fiftyPlus(\s|$)/.test(elem.className))
            elem.className += ' fiftyPlus';
}
function resetProgress(elem){
    elem.querySelector('.counter').setAttribute('data-percent',0);
    elem.querySelector('.progressEnd').style = {};
    elem.querySelector('.progress').style = {};
}

function isMobileDevice() {
    var check = false;
    (function(a){if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4))) check = true;})(navigator.userAgent||navigator.vendor||window.opera);
    return check;
};

// For Getting type of input tag
jQuery.fn.getType = function () { 
    if(this[0].tagName == "INPUT")
        return jQuery(this[0]).attr("type").toLowerCase() 
    else
        return this[0].tagName.toLowerCase();        
}

jQuery(document).ready(function($){
    
    // let optimize_started = <?=$optimize_started?>;
    // let optimization_status = <?=$optimize_progress?>;
    let optimize_started = 1;
    let optimization_status =1;
    if(optimize_started==1) {
        $('#optimizationFormSubmit').prop('disabled', true);
    }
    if(optimization_status==1){
        $("#loader").css("display","block");
        startOptimizationLoader1();
        // Don't run this function below
        // handleError();

    }
        
    // Fade in error messages/For paid version msg
    $('.err_trigger_class').click(function(){
        $(this).siblings('.err_class').show().fadeOut(5000);
        
    });
    // Fade in error messages/For paid version msg
    
    
    var pre_status = '<?=$ir_premi_status ?>'=='' ? true: false; 
    // For Default Settings button Start
    $('#default-settings').click((e)=>{
        e.preventDefault();
           $('input[name=rangeValOpt]').val(6500);
           $('#rangePath')[0].style.setProperty('--value',6500);
           $('#rangePercentOpt').text('65%')
        
           $('input[name=ir_viewport_status]').prop('checked',true);
           $('input[name=ir_progload_status]').prop('checked',true);
           if($('input[name=ir_border_status]').is(':checked')){
           $('input[name=ir_border_status]').click();
           }
           if($('input[name=ir_image_shadow]').is(':checked')){
            $('input[name=ir_image_shadow]').click();
           }
           $('input[name=ir_exif_status]').prop('checked',false);
            
       if(pre_status){
        //   $('input[name=ir_to_webp]').prop('checked',true);
            $("#f-option").prop("checked", true).trigger("click");
           $('input[name=ir_theme_image_status]').prop('checked',true);
           $('input[name=ir_amp_status]').prop('checked',true);
       }else{
            $("#s-option").prop("checked", true).trigger("click");
       }
       $('#default-settings').addClass('d-none');
    });
    // For Default Settings button End
    
    // For Showing/Hiding Default Settings button
    let default_settings_premium = {
     ir_toWebp:1,
     rangeValOpt:6500,
     ir_viewport_status:true,
     ir_progload_status:true,
     ir_theme_image_status:true,
     ir_amp_status:true,
     ir_theme_image_status:true,
     ir_exif_status:false,
     ir_border_status:false,
     ir_image_shadow:false,
     
    }
    let default_settings = {
     ir_toWebp:0,
     rangeValOpt:6500,
     ir_viewport_status:true,
     ir_progload_status:true,
     ir_theme_image_status:false,
     ir_amp_status:false,
     ir_theme_image_status:false,
     ir_exif_status:false,
     ir_border_status:false,
     ir_image_shadow:false,
     
    }
    let settings = pre_status ? default_settings_premium : default_settings ;
    var show = false;
        // For 1st page load
        $("form :input").each(function () {
            var type = $(this).getType();
            var name = $(this).attr('name'); 
            
            if(!(name in settings) || type=='hidden' ){
                // do nothing
            }else if (type == 'radio' && $(this).is(':checked')) { 
                show = (settings[name] != $(this).val());
            }   
            else if (type != 'checkbox' && type != 'radio') {
                show = (settings[name] != $(this).val());
            } else if (type == 'checkbox') {
                show = (settings[name] != $(this).is(':checked'));
            }    
            if (show) { return false; } // break out of loop
        });
        if(show){ $('#default-settings').removeClass('d-none'); }
        else{ $('#default-settings').addClass('d-none'); }

        
    
        // For Events (when form input changes)
    $('#optimizeMe').on('change keyup', function () {

        show = false;
        $("form :input").each(function () {
            var type = $(this).getType();
            var name = $(this).attr('name'); 
            
            if(!(name in settings) || type=='hidden' ){
                // do nothing
            }else if (type == 'radio' && $(this).is(':checked')) { 
                show = (settings[name] != $(this).val());
            }   
            else if (type != 'checkbox' && type != 'radio') {
                show = (settings[name] != $(this).val());
            } else if (type == 'checkbox') {
                show = (settings[name] != $(this).is(':checked'));
            }    
            if (show) { return false; } // break out of loop
        });
            if(show){ $('#default-settings').removeClass('d-none');}
            else{ $('#default-settings').addClass('d-none'); }

        
    });
    
    // For Showing/Hiding Default Settings button End
    
    // For Showing AMP Support messages start
    
    if(!$("input[name=ir_amp_status]").is(":checked")){
        $(".amp_support").hide();
    }
    $("input[name=ir_amp_status]").on("change",()=>{
        if($("input[name=ir_amp_status]").is(":checked")){
            $(".amp_support").show();
            $('input[name=ir_viewport]')
        }else{
            $(".amp_support").hide();
        }   
    });
    
    // For Showing AMP Support messages end
    


    // For  Enable/Disable Save Button Start
    var orig = [];             
    $("#optimizeMe :input").each(function () {
        var type = $(this).getType();
        if ( (type == 'radio' && !$(this).is(':checked')) 
            || !$(this)[0].hasAttribute('name')) { 
                return;
        }

        var tmp = {'type': type, 'value': $(this).val()};
        if (type == 'checkbox') { tmp.checked = $(this).is(':checked'); }
        orig[$(this).attr('name')] = tmp;
    });

    $('#optimizeMe').on('change keyup', function () {

        if(optimize_started == 0) return;

        var disable = true;
        $("form :input").each(function () {
            var type = $(this).getType();
            var name = $(this).attr('name'); 
            
            if(!(name in orig) || type=='hidden' ){
                disable = true;
            }else if (type == 'radio' && $(this).is(':checked')) { 
                disable = (orig[name].value == $(this).val());
            }   
            else if (type != 'checkbox' && type != 'radio') {
                disable = (orig[name].value == $(this).val());
            } else if (type == 'checkbox') {
                disable = (orig[name].checked == $(this).is(':checked'));
            }    
            if (!disable) { return false; } // break out of loop
            

        });

        $('#optimizationFormSubmit').prop('disabled', disable); // update button
        
    });

    loadCustomPath();


// Showing Success Message After registration
    let success = <?=$show_success?>;
    if(success=="true" || success==true){
        Swal.fire({
            title: 'Registeration Successfull !',
            text: "Go Fast GOWEBP",
            icon: 'success',
            confirmButtonColor:"#00d119"
        });
    }
// Showing Success Message After registration End


    let before_img_size = 0;
    let img_size_unit = "mb";
    // Image Shadow
    if($("input[name=ir_image_shadow]").is(":checked")){
        $(".subShadow").css("display","block");
        let size = $("input[name=shadow_size]").val();
        let color = convertToRGB($("input[name=shadow_color]").val());
        let opacity = $("input[name=shadow_opacity]").val();
        if(opacity>=1){
            opacity = 0.9;
        }
        $("#previewImage").css("box-shadow",`0 0 ${size}px rgba(${color},${opacity})`);

    }else{
        $(".subShadow").css("display","none");
        $("#previewImage").css("box-shadow","none");

    }
    
    
    $("input[name=ir_image_shadow]").on("change",()=>{
        $(".subShadow").fadeToggle();
        if($("input[name=ir_image_shadow]").is(":checked")){
        let size = $("input[name=shadow_size]").val();
        let color = convertToRGB($("input[name=shadow_color]").val());
        let opacity = $("input[name=shadow_opacity]").val();
        if(opacity>=1){
            opacity = 0.9;
        }
        $("#previewImage").css("box-shadow",`0 0 ${size}px rgba(${color},${opacity})`);
        }else{
            $("#previewImage").css("box-shadow","none");

        }
    });
    // Show Shadow
    $("input[name=shadow_size],input[name=shadow_color],input[name=shadow_opacity]")
    .on("input",function(){
        let size = $("input[name=shadow_size]").val();
        let color = convertToRGB($("input[name=shadow_color]").val());
        let opacity = $("input[name=shadow_opacity]").val();
        if(opacity>=1){
            opacity = 0.9;
        }
        $("#previewImage").css("box-shadow",`0 0 ${size}px rgba(${color},${opacity})`);
    });


    // Image Shadow  End 

    // Tooltip Activation
    $(".t-1").tooltip({
        trigger:'hover focus manual'
    });
    // Tooltip Activation

    let a = $("input[name=ir_progload_status]").is(":checked");
    
    // Before Optimization Image Size End

    // Custom Size
    $("#custom_size").on("click",function(){
        $("#custom_size_div").slideToggle();
        $("#arrow").toggleClass("fa-caret-down");
        $("#arrow").toggleClass("fa-caret-up");    
    })
    // Custom Size End

    // Progressive Load Toggle
    $("input[name=ir_progload_status]").on("change",function(){
        if($(this).is(":checked")){
            $("#previewImage").css("filter","blur(0.6em)");
            setTimeout(() => {
            $("#previewImage").css("filter","blur(0em)");
            }, 800);
            // change here
            $("input[name=ir_viewport_status]").prop("checked",true);
        }
    });
    // Progressive Load Toggle End

    // Border
    let border_status = "<?=$ir_border_status ?>";
    if(border_status=="checked"){
        $(".subBorder").css("display","block");
        let border = "<?=$border_size."px solid"?>";
        let border_radius = "<?=$border_radius."px" ?>";
        $("#previewImage").css({
            "border-radius":border_radius,
            "border":border,
            "border-color":"<?=$border_color ?>"
        });
    }else{
        $(".subBorder").css("display","none");
    }

    $("input[name=ir_border_status]").on("change",function(){
        if($(this).is(":checked")){
            $(".subBorder").fadeIn();
            $("#previewImage").css("border",$("input[name=border_size]").val()+"px solid");
            $("#previewImage").css("border-radius",$("input[name=border_radius]").val()+"px");
            $("#previewImage").css("border-color",$("input[name=border_color]").val());
        }else{
            $("#previewImage").css("border","none")
            $("#previewImage").css("border-radius","0px")
            $(".subBorder").fadeOut();
        }
    })

    $("input[name=border_radius]").on("input",function(){
        $("#previewImage").css("border-radius",$(this).val()+"px");
    });
    $("input[name=border_size]").on("input",function(){
        $("#previewImage").css("border",$(this).val()+"px solid");
        $("#previewImage").css("border-color",$("input[name=border_color]").val());
    });
    $("input[name=border_color]").on("input",function(){
        $("#previewImage").css("border-color",$(this).val());

    });
    // Border ENd
    // 
    $("#ir_startOptimization").click(function(){
        event.preventDefault();
        $.ajax({
            xhr: function() {
                var xhr = new window.XMLHttpRequest();
                xhr.upload.addEventListener("progress", function(evt) {
                    if (evt.lengthComputable) {
                        var percentComplete = (evt.loaded / evt.total) * 100;
                        // Place upload progress bar visibility code here
                        $(".ir_progress_loader").fadeIn();
                        $("#ir_progress_bar").animate({"width":"50%"},{duration:1000});
                    }
                }, false);
                return xhr;
            },
            url:"<?php echo admin_url( "admin-ajax.php" ) ?>",
            type:"POST",
            data:{
                action:"irStartOptimization",
                start: "1"
            },
            beforeSend: function(){
                $("#loaderOpt").toggleClass("d-none");
            },
            success: function(response){
                $("#loaderOpt").toggleClass("d-none");
                $(".ir_progress_loader").fadeOut();
                if(response == "Limit Reached"){
                    Swal.fire({
                        title: 'Limit Reached!',
                        text: "Upgrade  to GOWEBP Pro for Optimizing More Images.",
                        icon: 'warning',
                        confirmButtonColor:"#f1c40f"
                    });
                }else{
                    // -here
                    // $("#total_images_opt").html(parseInt($("#total_images").html()));
                    Swal.fire({
                        title: 'Optimization Started!',
                        text: "Image Optimization has been started in background.",
                        icon: 'success',
                        confirmButtonColor:"#00d119"
                    });
                }
            }
        });
    });

    // Heading Channge
    $("#profile-tab").click(()=>{
        $("#iAmToggle").html("Optimization Manager");
    });
    $("#home-tab").click(()=>{
        $("#iAmToggle").html("Ad Manager");
    });
    // Heading Channge End--

    //Optimization Form
    $("#optimizationFormSubmit").on("click",function(){
            event.preventDefault();
            let data = new FormData(document.getElementById("optimizeMe"));
                    // 
                    $.ajax({
                        url:"<?=admin_url("admin-ajax.php")?>",
                        type:"POST",
                        data:data,
                        processData:false,
                        contentType:false,
                        beforeSend:function(){
                            $("#loaderOpt").toggleClass("d-none");
                            // $("#remaining_images").removeClass("d-none");
                            // $("#remaining_images").addClass("d-inline-block");
                            $('#optimizationFormSubmit').prop('disabled', true); 

                            $("#loader").fadeIn();
                            
                            // loeader1();
                        },
                        success:function(response){
                            $("#loader").fadeOut();
                            if(response == "Limit Reached"){
                                Swal.fire({
                                    title: 'Limit Reached!',
                                    text: "Upgrade  to GOWEBP Pro for Optimizing More Images.",
                                    icon: 'warning',
                                    confirmButtonColor:"#f1c40f"
                                });
                            }else{
                                // $("#total_images_opt").html(parseInt($("#total_images").html()));
                                Swal.fire({
                                    title: 'Optimization Started!',
                                    text: "Image Optimization has been started in background.",
                                    icon: 'success',
                                    confirmButtonColor:"#00d119"
                                });
                                $("#total_images_opt").html(response);
                                document.cookie = "ir_cookie_stats=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;";
                                document.cookie = "ir_cookie_stats2=; expires=Thu, 01 Jan 1970 00:00:00 UTC; path=/;";
                                console.log("Optimized Images: "+response);
                            }
                            // $("#remaining_images").removeClass("d-inline-block");
                            // $("#remaining_images").addClass("d-none");

                            $('#optimizationFormSubmit').prop('disabled', false); 
                            irGetImgStats();
                        },
                        error: function(request, status, err){
                            handleError();
                            irGetImgStats();
                        }
                    });
            
        });

    $("#rangeValOpt").on("input",function(){
        let percent  = parseInt($(this).val())/100;
        percent  = percent<=90 ? percent : 90;
        $("#rangePercentOpt").html(percent+"%");
        if(percent>90){
            $(this).prop("value","9000");
        }
        if(percent>=70){
            $(this).prop("step","100");
        }else{
            $(this).prop("step","500");
        }
        // // Image Space after Optimization//
        let opt_level = 100 - parseFloat(percent);
        before_img_size = parseFloat($("#before_img_size").html());
        let after_img_size = round(opt_level*(before_img_size/100),2);
        $("#after_img_size").html(after_img_size+" "+img_size_unit);
    });
    $("#rangeValOpt").on("change",function(){

    });

    $("#defaultRangeOpt").on("click",function(){
        event.preventDefault();
        $("#rangeValOpt").val(6500)
        $("#rangePercentOpt").html("65%");
    })
    
    // Optimize  Form End

    // Premium Errors
    $(".err_trigger_class").on("click", function(){
        $(".ir_error").fadeIn();
        $(".ir_error").fadeOut(8000);
    })

    // Custom Path Start
    $("#customPathSubmit").click(()=>{
        let btn= $(this);
        let path = $("#customPath").val();
        if(path==""){
            Swal.fire({
                title: 'Please Enter Path!',
                text: "Enter valid server path.",
                icon: 'error',
                confirmButtonColor:"#00d119"
            });
            return;

        }

        $.ajax({
            url:"<?=admin_url( "admin-ajax.php" ) ?>",
            type:"POST",
            data:{path,action:"ir_add_custom_img_path"},
            beforeSend: ()=>{
               btn.attr("disabled", true);
               $("#loadCustomPath").hide();
               $("#pathsLoader").show();

            },
            success:  (data)=>{
              irGetImgStats();
                if(data=="added"){
                    Swal.fire({
                        title: 'Path Added Successfully!',
                        text: "The images from this url will be optimized.",
                        icon: 'success',
                        confirmButtonColor:"#00d119"
                    });
                }
                else if(data=="exists"){
                    Swal.fire({
                        title: 'Path Already Exists!',
                        text: "Enter different path.",
                        icon: 'warning',
                        confirmButtonColor:"#00d119"
                    });
                }
                else{
                    Swal.fire({
                        title: 'Invalid Path !',
                        text: `'<?=site_url() ?>/${path}' path does not exist on server`,
                        icon: 'error',
                        confirmButtonColor:"#00d119"
                    });
                    
                }
                $("#customPath").val("");
                loadCustomPath();
                btn.attr("disabled", false);


            },
            error: (data)=>{
              irGetImgStats();
                btn.attr("disabled", false);
                console.log(data);
            }
        })

       
    });
    // Custom Path End
    
    // Registration Form JS Start
    $("#reg_form").on("submit",(e)=>{
          e.preventDefault();
          let key = $("input[name=reg_key]").val();
          console.log(key);
          if(key==""){
            Swal.fire({
                title: 'Enter Registeration Key',
                text: "Please enter your registeration key.",
                icon: 'warning',
                confirmButtonColor:"#00d119"
            });
          }else{
          let fd = new FormData($("#reg_form")[0]);
    
          $.ajax({
            url: "<?=admin_url("admin-ajax.php") ?>",
            type:"POST",
            data:fd,
            processData:false,
            contentType: false,
            beforeSend: function(){
              let loader = `
              <div class="btn-search">
                  <div style="width:fit-content;margin:auto;padding-top:10px">
                    <div class="loader-register"></div>
                  </div>
                </div>
              `;
              $("#sub").html(loader);
    
            },
            success: (response)=>{
                console.log(response);
              if(response=="failed"){
                Swal.fire({
                    title: 'Invalid Registeration Key',
                    text: "Please enter your registeration key.",
                    icon: 'error',
                    confirmButtonColor:"#00d119"
                });
                $("#sub").html(`
                <button type="submit" id="reg_sub" class="btn-search" type="button">
                  <strong> Reigster </strong>
                </button>
                `);
                $("#reg_form").trigger("reset");
              }
              else{
                window.location.reload();
              }
            },
            error: (err)=>{
              console.log(err);
            }
    
          })
    
          }
    
        })
    // Registration Form JS End


    });


function ir_setCookie(cname,cvalue,exdays) {
  const d = new Date();
  d.setTime(d.getTime() + (exdays*24*60*60*1000));
  let expires = "expires=" + d.toUTCString();
  document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function ir_getCookie(cname) {
  let name = cname + "=";
  let decodedCookie = decodeURIComponent(document.cookie);
  let ca = decodedCookie.split(';');
  for(let i = 0; i < ca.length; i++) {
    let c = ca[i];
    while (c.charAt(0) == ' ') {
      c = c.substring(1);
    }
    if (c.indexOf(name) == 0) {
      return c.substring(name.length, c.length);
    }
  }
  return "";
}


    // Ajax Functions Start
    function irGetImgStats(status123=false){
        jQuery.ajax({
            url:"<?=admin_url('admin-ajax.php') ?>",
            type:'POST',
            data:{
                action:"ir_get_img_stats"
            },
            beforeSend: function(){
              loeader1();
                jQuery("#startSettings").css("display","none");
            }
            ,
            success:function(response){
                response = JSON.parse(response);
                
                let img_count = response.image_count;
                let opt_img_count = response.optimized_image_count;
                  
                let ir_cookie_stats = ir_getCookie("ir_cookie_stats");
                if (ir_cookie_stats != "") {
                  
                  if(parseInt(opt_img_count)>parseInt(ir_cookie_stats)){
                    opt_img_count=opt_img_count
                    ir_setCookie("ir_cookie_stats", opt_img_count, 30);
                    ir_setCookie("ir_cookie_stats2", img_count, 30);
                  }else{
                    opt_img_count=ir_cookie_stats;
                  }

                } else {
                  ir_setCookie("ir_cookie_stats", opt_img_count, 30);
                  ir_setCookie("ir_cookie_stats2", img_count, 30);
                }

                before_img_size = response.total_size;
                img_size_unit = "bytes";
                if(before_img_size >= 1024*1024*1024){
                    before_img_size /= 1024*1024*1024;
                    img_size_unit = "gb";
                }else if(before_img_size >= 1024*1024){
                    before_img_size /= 1024*1024;
                    img_size_unit = "mb";
                }else if(before_img_size >= 1024){
                    before_img_size /= 1024;
                    img_size_unit = "kb";
                }
                before_img_size = round(before_img_size,2);
                
                jQuery(".total_images_loader").toggleClass("d-none");

                jQuery("#total_images").html(img_count);
                jQuery("#total_images_opt").html(opt_img_count);

                // Image Space after Optimization
                let opt_level = 100 - parseFloat(jQuery("#rangeValOpt").val());
                let after_img_size = Math.abs(round((opt_level/100)*(before_img_size/100.0),2));
                let saved_img_size = Math.round(before_img_size-after_img_size);
                jQuery("#before_img_size").html(before_img_size+" "+img_size_unit);
                jQuery("#after_img_size").html(after_img_size+" "+img_size_unit);
                jQuery("#saved_img_size").html(saved_img_size+" "+img_size_unit);

                jQuery("#startSettings").css("display","flex");
                jQuery("#startSettings_loader").toggleClass("d-none");
                jQuery(".img-count-loader").removeClass("d-inline-block")
                jQuery(".img-count-loader").addClass("d-none");

                if(status123){
                  loeader1(false);
                }
                

            },
            error: function(err){
                console.log(err);
            }

        })
    }
    // Ajax Functions End
    
    // Handle errors like timeout
    function handleError(){
        jQuery.ajax({
            url:'<?=admin_url('admin-ajax.php')?>',
            type:'POST',
            data:{action:'ir_handle_error'},
            success:function(response){
                jQuery('#optimizationFormSubmit').prop('disabled', false);
                // jQuery('#remaining_images').addClass("d-none");
                jQuery('#total_images_opt').text(jQuery('#total_images').text());
            },
            error:function(request){
                console.log('another error');
                handleError();
            }
        });
    }
    // Handle errors like timeout
    

    // Load External Url
    function loadExternalUrls(){
        jQuery.ajax({
            url:"<?=admin_url("admin-ajax.php") ?>",
            type:"POST",
            data: {action:"loadExternalUrls"},
            success:function(data){
                let table = jQuery("#loadExternalUrls");
                data = JSON.parse(data);
                if(data.length>0){
                    html = '';
                    for(row of data){
                        html += `
                            <tr>
                                <td>${row.url}</td>
                                <td> <button class="btn btn-danger" onclick='delExUrl(${row.id})'>Delete</button></td>
                            </tr>
                        `;
                    }
                    table.html(html);

                }else{
                    table.html(`
                        <tr>
                            <td>No External Url Inserted.</td>
                            <td></td>
                        </tr>
                    `)
                }
            },
            error: function(data){
                console.log(data);
            }
        });
    }

// External Url Delete
    function delExUrl(id){

        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#f1c40f',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
            if (result.isConfirmed) {
                jQuery.ajax({
                    url:"<?=admin_url("admin-ajax.php") ?>",
                    type:"POST",
                    data: {action:"delExternalUrls", id},
                    success: function(data){
                        Swal.fire({
                            title: 'Url Deleted Successfully!',
                            text: "The optimized image has been removed.",
                            icon: 'success',
                            confirmButtonColor:"#00d119"
                        });
                        loadExternalUrls();
                    },
                    error: function(data){
                        console.log(data)
                    }
                })    
            }
            })
        
    }

    function loadCustomPath(){
        let loader = jQuery("#pathsLoader");

        jQuery.ajax({
            url:"<?=admin_url("admin-ajax.php") ?>",
            type:"POST",
            data: {action:"load_custom_paths"},
            beforeSend:()=>{
                loader.show();
                jQuery("#loadCustomPath").hide();
                // irGetImgStats();
            },
            success:function(data){
                let table = jQuery("#loadCustomPath");
                data = JSON.parse(data);
                if(data.length>0){
                    html = `
                        <table class="table table-striped">
                        <thead>
                            <tr>
                                <th>Path</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                        <tbody>

                    `;
                    for(row of data){
                        html += `
                            <tr>
                                <td>${row}</td>
                                <td> <button class="btn btn-sm btn-danger" onclick='delCustomPath.bind(this)("${row}")'>Delete</button></td>
                            </tr>
                        `;
                    }
                    html+= `
                        </tbody>
                        </table>
                    `;
                    table.html(html);

                }else{
                    table.html(`
                        <div class="bg-light p-1" style='width:100%;margin-top:-20px'>
                            <h5 class='ml-3 text-secondary'>No Custom Path Inserted</h5>
                        </div>
                    `);
                }
                loader.hide();
                jQuery("#loadCustomPath").show();
                // irGetImgStats();
            },
            error: function(data){
                console.log(data);
                loader.hide();
                jQuery("#loadCustomPath").show();

            }
        });
    }

    // Custom Path Delete
    function delCustomPath(path){
        let element = this;
        event.preventDefault();
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#00d119',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
            if (result.isConfirmed) {
                jQuery.ajax({
                    url:"<?=admin_url("admin-ajax.php") ?>",
                    type:"POST",
                    beforeSend:()=>{
                        jQuery(element).closest("tr").fadeOut();
                        
                    },
                    data: {action:"del_custom_paths", path},
                    success: function(data){
                    },
                    error: function(data){
                        console.log(data)
                    }
                })    
            }
            })
    }


    // Optimization Loader
    function startOptimizationLoader(percent=0){
        if(percent>=100 || percent==99){
            resetProgress(document.querySelector('.circlePercent'));
            jQuery("#loader").fadeOut();
            return;
        }
        var elem = document.querySelector('.circlePercent');
        setProgress(elem,percent);
        jQuery.ajax({
            url:"<?=admin_url('admin-ajax.php') ?>",
            type:"POST",
            data:{
                action:"ir_check_opt_progresss"
            },
            success:function(data){
                startOptimizationLoader(data);
            },
            error:function(data){
                console.log(data);
            }
        });
        
    }
        // Optimization Loader
    function startOptimizationLoader1(percent=0){
        if(percent>=100 || percent==99){
            resetProgress(document.querySelector('.circlePercent'));
            jQuery("#loader").fadeOut();
            return;
        }
    }

function loeader1(status=true){
    
    if(status){
      // console.log("lod show");
      jQuery("#myloader1").fadeIn();
      jQuery("#remaining_images").removeClass("d-none");
      jQuery("#remaining_images").addClass("d-inline-block");
    }else{
      // console.log("lod hide");
      jQuery("#myloader1").fadeOut();
      jQuery("#remaining_images").removeClass("d-inline-block");
     jQuery("#remaining_images").addClass("d-none");
    }
}


function compressimage(){


  loeader1();
  jQuery.ajax({
            url:"<?=admin_url('admin-ajax.php') ?>",
            type:"POST",
            data:{
                action:"ir_compressimg"
            },
            beforeSend:()=>{
                irGetImgStats();
            },
            success:function(data){
              if(data=="completed" || data=="completed0" || data=="completed1"){
                console.log(data);
                // console.log("done");
                loeader1(false);
                irGetImgStats(true);
              }else{
                console.log(data);
                irGetImgStats();
                compressimage();
                loeader1();
              }
            },
            error:function(data){
              console.log("asderrror123");
              loeader1();

              compressimage();
              irGetImgStats();
                console.log(data);
            }
        });

}

setTimeout(compressimage, 3000);

</script>
<script src="<?=plugin_dir_url( __FILE__ )."lib/js/option.js" ?>"></script>

<?php 
if(isset($progressbar_show)){

  if($progressbar_show=="show"){
    echo "<script>loeader1()</script>";
  }
}
?>

<?php
}elseif($gowebp_ir->ir_check_server()){ ?>
<div class="wrap" id="notfound">
	<div class="notfound">
		<!-- <div class="notfound-404">
			<h1></h1>
		</div> -->
        <div style="position:relative;top:-50px">
            <img width=400px src="<?=plugin_dir_url( __FILE__ )."/lib/img/gowebp-logo.png" ?>" alt="">
        </div>
		<h2 style="margin-top:-20px">Localhost Error !</h2>
		<p>Install Gowebp on hosting</p>
		<a href="https://gowebp.com/#pricing" target="_blank" >Get GowebP</a>
	</div>
</div>

<?php
}else{
$domain = sanitize_text_field( $_SERVER["HTTP_HOST"] );
$domain = str_replace(['http://','https://','www.'],'',$domain);
?>
<div id="notfound">
  <div class="notfound">
      <div class="notfound-404">
          <h1>Trial Ended</h1>
      </div>
      <h2>Your Trial Period Has Ended!</h2>
      <p>Get paid version of gowebp to optimize  more than 1000 images.</p>
      <a href="https://gowebp.com/#pricing?domain=<?=$domain ?>" target="_blank" >Get GowebP</a>
  </div>
</div>
<?php } ?>

